MarkerSafeEntregadorDeJornal = createMarker( 765.68848, -1355.44495, 13.52570, "cylinder", 35, 0, 255, 0, 0)

EntregadorDeJornalPickup = createPickup ( 783.27710, -1327.66260, 13.54688, 3, 1210)
MarkerEntregadorDeJornal = createMarker ( 783.27710, -1327.66260, 13.54688, "cylinder", 1.2, 255, 255, 255, 0 )
attachElements ( MarkerEntregadorDeJornal, EntregadorDeJornalPickup, 0, 0, -1 )
BlipEntregadorDeJornal = createBlipAttachedTo ( MarkerEntregadorDeJornal, 42 )
setBlipVisibleDistance ( BlipEntregadorDeJornal, 150 )

function CancelarSumirPickup ( player )
   cancelEvent()
end
addEventHandler ( "onPickupHit", EntregadorDeJornalPickup, CancelarSumirPickup )

LetraParaMarkers = "k"
cmd1 = "hq"
cmd2 = "profissao"

local HQEntregadorDeJornalBlip = createBlip ( 783.27710, -1327.66260, 13.54688 )
setElementVisibleTo ( HQEntregadorDeJornalBlip, root, false )

--------------------------------------------------------------------

function VerificarBlipEmprego(player)
  if player then
  acc = getPlayerAccount ( player )
  if isGuestAccount ( acc ) then return end
  setElementVisibleTo ( HQEntregadorDeJornalBlip, player, false )
  end
end

setTimer(
function()
	for i, pl in pairs(getElementsByType("player")) do
		if pl ~= (false or nil) then
		    if getElementData ( pl, "Emprego" ) == "Entregador de Jornal" then return end
			   VerificarBlipEmprego(pl)
		end
	end
end,
3000,0)

--------------------------------------------------------------------

function ComandoHQ ( source )
    if getElementData ( source, "Emprego" ) == "Entregador de Jornal" then
	if isElementVisibleTo ( HQEntregadorDeJornalBlip, source ) then
	setElementVisibleTo ( HQEntregadorDeJornalBlip, source, false )
	exports.Hype_MensagemDX:outputDx(source, "Seu Local de Trabalho foi Desmarcado do Mapa!", "info")
	else
	setElementVisibleTo ( HQEntregadorDeJornalBlip, source, true )
	exports.Hype_MensagemDX:outputDx(source, "Seu Local de Trabalho foi Marcado no Mapa!", "info")
end
end	
end    
addCommandHandler ( cmd1, ComandoHQ )

--------------------------------------------------------------------

function AceitarEmprego02 (source)
exports.Hype_MsgsMarker:delete(source)
unbindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
if getElementData ( source, "Hype>Encaminhamento" ) == "Entregador de Jornal" then
setElementData ( source, "Hype>Encaminhamento", false )
setElementData ( source, "Emprego", "Entregador de Jornal" )
exports.Hype_MensagemDX:outputDx(source, "Você Agora Trabalha de Entregador de Jornal, Para Mais Informações Digite ( /Profissao )", "success")
else
exports.Hype_MensagemDX:outputDx(source, "Você Precisa Estar Encaminhado da Agencia de Empregos para Trabalhar neste Local!", "error")
end
end

function RecusarEmprego02 (source)
exports.Hype_MsgsMarker:delete(source)
unbindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
if isElementVisibleTo ( HQEntregadorDeJornalBlip, source ) then
setElementVisibleTo ( HQEntregadorDeJornalBlip, source, false )
end
removeElementData ( source, "Emprego", "Entregador de Jornal" )
exports.Hype_MensagemDX:outputDx(source, "Você se Demitiu do Emprego de Entregador de Jornal com Sucesso!", "warning")
end

--------------------------------------------------------------------

function ComandosProf ( ThePlayer )
if getElementData ( ThePlayer, "Emprego" ) == "Entregador de Jornal" then
playSoundFrontEnd ( ThePlayer, 43 )
outputChatBox ( "#F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #F96031Profissão #F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #BEE09AComandos da Profissão de Entregador de Jornal", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #55D444/HQ #ffffff- #9ABDE0Para Marcar / Desmarcar o seu Local de Trabalho", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #55D444/Rotas #ffffff- #9ABDE0Abre a Lista de Rotas Disponiveis Para Trabalhar", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #FFD700Entre na Bike e Digite /Rotas Selecione uma Rota e Siga os Checkpoints!", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #F96031Profissão #F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~", ThePlayer, 255, 255, 255, true )
end
end
addCommandHandler(cmd2, ComandosProf )

--------------------------------------------------------------------

function emarker(marker,md) 
	if (md) then
	  if isPedInVehicle ( source ) then return end
		if marker == MarkerEntregadorDeJornal then
		    if getElementData ( source, "Emprego" ) == "Entregador de Jornal" then
			exports.Hype_MsgsMarker:create(source,"Aperte 'K' Para se Demitir do Emprego de Entregador de Jornal")
			bindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
		else
			exports.Hype_MsgsMarker:create(source,"Aperte 'K' Para Aceitar o Emprego de Entregador de Jornal")
			bindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
		end
	 end
  end	
end
addEventHandler("onPlayerMarkerHit",getRootElement(),emarker)

function lmarker(marker,md)
	if (md) then
		if marker == MarkerEntregadorDeJornal then
			exports.Hype_MsgsMarker:delete(source)			
			unbindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
			unbindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
		end
	end
end
addEventHandler("onPlayerMarkerLeave",getRootElement(),lmarker)

local vehiclesToSpawn =
{
	{ 510, 785.35528564453,-1337.6834716797+0,13.14189491272, 90 },
	{ 510, 785.35528564453,-1337.6834716797+3,13.14189491272, 90 },
	{ 510, 785.35528564453,-1337.6834716797+6,13.14189491272, 90 },
}

local vehicleDestroyTimers = {}
local playerVehicles = {}

local function destroyPlayerVehicles()
	local vehicles = playerVehicles[source]
	for _,vehicle in ipairs(vehicles) do
		if isElement(vehicle) then
			destroyElement(vehicle)
		end
	end
	playerVehicles[source] = nil
end

local function onEnter(player)
	local t = tonumber(get("vehicleRespawnTime")) or 60000
	source.damageProof = false
	source.frozen = false
	local vehicledata = vehiclesToSpawn[source]
	setTimer(createNewVehicle,(t > 50 and t or 50),1,vehicledata)
	vehiclesToSpawn[source] = nil
	if not playerVehicles[player] then
		playerVehicles[player] = {}
		addEventHandler("onPlayerQuit",player,destroyPlayerVehicles)
	end
	table.insert(playerVehicles[player],source)
	removeEventHandler("onVehicleEnter",source,onEnter)
end

local function destroyVehicle(vehicle)
	if vehicle and isElement(vehicle) and getElementType(vehicle) == "vehicle" then
		destroyElement(vehicle)
	end
end

local function destroyTimer()
	if vehicleDestroyTimers[source] and isTimer(vehicleDestroyTimers[source]) then killTimer(vehicleDestroyTimers[source]) end
	removeEventHandler("onVehicleEnter",source,destroyTimer)
end

local function onExit()
	local t = tonumber(get("vehicleExpireTime")) or 600000
	vehicleDestroyTimers[source] = setTimer(destroyVehicle,(t > 50 and t or 50),1,source)
	addEventHandler("onVehicleEnter",source,destroyTimer)
end

function VerificarEmprego ( thePlayer, seat )
    local Jogador = getElementData ( thePlayer, "Emprego" )
    if seat == 0 then
        if Jogador == "Entregador de Jornal" then
		    -- Entra no Veiculo (OK!)
		else
            cancelEvent ( )
            exports.Hype_MensagemDX:outputDx ( thePlayer, "Veiculo Exclusivo de Profissão!", "error" )
		end
    end
end

function createNewVehicle(vehicledata)
	local m,x,y,z,r = unpack(vehicledata)
	local vehicle = Vehicle(m,x,y,z,0,0,r)
	vehicle.damageProof = true
	vehicle.frozen = true
	vehiclesToSpawn[vehicle] = vehicledata
	addEventHandler("onVehicleEnter",vehicle,onEnter)
	addEventHandler("onVehicleExit",vehicle,onExit)
	addEventHandler("onVehicleStartEnter",vehicle,VerificarEmprego )
end

local function initScript()
	for _,vehicledata in ipairs(vehiclesToSpawn) do createNewVehicle(vehicledata) end
end
addEventHandler("onResourceStart",resourceRoot,initScript)

--------------------------------------------------------------------

atualrotnumberJORNAL = {}
ppcikJORNAL = {}
blips = {}

VALOR_POR_JORNAL = 125

rotasJORNAL = {
	["Entregas de Jornais - Los Santos (1) - 20 Entregas - $"..VALOR_POR_JORNAL.." por Jornal"] = {
		{993.64386, -1050.08850, 30.72189},
		{1051.22083, -1049.50073, 31.70257},
		{1117.78308, -1030.55933, 31.88287},
		{1190.73914, -1027.36011, 32.35918},
		{1466.25684, -1172.65686, 23.88302},
		{1673.56787, -1169.50952, 23.92861},
		{1791.41406, -1164.77539, 23.82813},
		{2095.31763, -1292.43701, 23.97214},
		{2150.26270, -1291.66003, 23.97753},
		{2352.69019, -1513.26306, 24.00000},
		{2561.87158, -1467.34753, 24.01236},
		{2756.12573, -1180.33130, 69.39844},
		{2863.57446, -1440.18982, 10.95315},
		{2507.24414, -1725.65881, 13.54688},
		{2390.33276, -1721.86511, 13.58705},
		{2228.38867, -1722.77356, 13.55438},
		{2175, -1742, 13.55438},
		{2072.61230, -1793.96008, 13.54688},
		{1871.15784, -1923.91858, 13.54688},
		{1352.39136, -1758.33508, 13.50781},
	},
	["Entregas de Jornais - Los Santos (2) - 20 Entregas - $"..VALOR_POR_JORNAL.." por Jornal"] = {
		{823.93018, -1413.86011, 13.46503},
		{909.32098, -1504.01135, 13.54223},
		{797.72333, -1580.37390, 13.54688},
		{645.75140, -1694.06555, 14.89330},
		{422.36475, -1758.63403, 8.18526},
		{305.55188, -1771.70020, 4.54249},
		{168.62589, -1770.10681, 4.43438},
		{138.38370, -1460.07129, 25.62103},
		{169.82892, -1348.34363, 69.36220},
		{280.87973, -1320.37817, 53.81308},
		{543.01135, -1202.30334, 44.50127},
		{562.19452, -1060.57458, 74.59800},
		{782.98035, -808.70764, 65.19865},
		{908.08984, -684.05566, 116.23006},
		{1091.30396, -627.89929, 111.38203},
		{1280.77197, -614.80652, 102.93521},
		{1437.30725, -935.30865, 36.26117},
		{1335.64368, -1066.11133, 27.87136},
		{1144.98792, -1131.54431, 23.82813},
		{1022.52026, -1122.13037, 23.87152},
	},
	["Entregas de Jornais - Los Santos (3) - 20 Entregas - $"..VALOR_POR_JORNAL.." por Jornal"] = {
		{928.972, -1501.915, 13.688},
		{1022.285, -1549.933, 13.7},
		{936.118, -1729.083, 13.693},
		{1230.371, -1824.298, 13.732},
		{1410.103, -1880.521, 13.696},
		{1758.215, -1862.219, 13.722},
		{1828.75708, -1684.37939, 13.71004},
		{1500.16882, -1585.15295, 13.71064},
		{1461.40417, -1273.39014, 13.69502},
		{1487.07031, -1123.84973, 24.17703},
		{1629.44714, -1169.14404, 24.25320},
		{1788.94141, -1167.61694, 23.98698},
		{1881.36816, -1266.11792, 13.68557},
		{1671.04395, -1312.91003, 14.32398},
		{2077.65332, -1199.52319, 24.03867},
		{2230.93481, -1142.54358, 25.94684},
		{2718.10181, -1224.61157, 63.86625},
		{2431.31226, -1739.74988, 13.76650},
		{2426.02319, -1508.47717, 24.15445},
		{2139.46191, -1379.86865, 23.97519},
	},
}

pay = {
	["Entregas de Jornais - Los Santos (1) - 20 Entregas - $"..VALOR_POR_JORNAL.." por Jornal"] = 0,
	["Entregas de Jornais - Los Santos (2) - 20 Entregas - $"..VALOR_POR_JORNAL.." por Jornal"] = 0,
	["Entregas de Jornais - Los Santos (3) - 20 Entregas - $"..VALOR_POR_JORNAL.." por Jornal"] = 0,
}

function ifPlayerEnterOnMarker(markerHit,matchingDimension)
	if isPedInVehicle(source) then
		if markerHit == ppcikJORNAL[source] then
			if (matchingDimension) then
				if isElement(ppcikJORNAL[source]) then
					local rname = getElementData(source,"rtnameJornal") or nil
					if rname == nil then return end
					destroyElement(ppcikJORNAL[source])
					triggerClientEvent(source,"Hype>JOBEntregadorDeJornal>blips<Client",source,false)
					local vh = getPedOccupiedVehicle(source)
					
					toggleAllControls ( source, false )
					setControlState ( source, "handbrake", true )
					
					if atualrotnumberJORNAL[source] <= #rotasJORNAL[rname] then
					    exports.Hype_MensagemDX:outputDx(source, "Entregando Jornais... Aguarde 2 Segundos!", "info")
						
						setElementData ( source, "HypeSCR_LiberarXP", "Sim" )
						givePlayerMoney ( source, VALOR_POR_JORNAL )
						
						setTimer(gerarrota,2500,1,source)
						setTimer(function(source) exports.Hype_MensagemDX:outputDx(source, "Jornais Entregues, Siga Para o Proximo Checkpoint!", "success") end,2500,1,source)
					elseif atualrotnumberJORNAL[source] == #rotasJORNAL[rname]+1 then
						setElementData(source,"rtnameJornal",rname)
						atualrotnumberJORNAL[source] = 1
						local rec = pay[rname]
						givePlayerMoney(source,tonumber(rec))	
						local vh = getPedOccupiedVehicle(source)
						setTimer(function(source) exports.Hype_MensagemDX:outputDx(source, "Você Recebeu um Valor de $"..rec.." Por Finalizar as Entregas de Jornais!", "success") end,2500,1,source)
						setTimer(function(source) toggleAllControls ( source, true ) end, 2500,1, source )
						setTimer(function(source) setControlState ( source, "handbrake", false ) end, 2500,1, source )
						setElementData(source,"rtnameJornal",nil)	
					end

					
				end
			end	
		end
	end
end
addEventHandler("onPlayerMarkerHit",getRootElement(),ifPlayerEnterOnMarker)

--------------------------------------------------------------------

function VerificarCairBike(player)
  if player then
  acc = getPlayerAccount ( player )
  if isGuestAccount ( acc ) then return end
  local rname = getElementData(player,"rtnameJornal") or nil
  if rname == nil then
  triggerClientEvent ( "Desligar:AntiQueda", player )
  else
  triggerClientEvent ( "Ligar:AntiQueda", player )
  end
 end		
end

setTimer(
function()
	for i, pl in pairs(getElementsByType("player")) do
		if pl ~= (false or nil) then
		    if getElementData ( pl, "Emprego" ) == "Entregador de Jornal" then
			   VerificarCairBike(pl)
			end
		end
	end
end,
3000,0)

--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function pickjobJornal(source)
	if not isElement(source) then return end
	local im = isPedInVehicle(source)
	if im == false then return end	
	local job = getElementData(source,"Emprego") or false
	if job == "Entregador de Jornal" then
	local vh = getPedOccupiedVehicle(source)
	if isElement(vh) then
		local x,y = getElementPosition(vh)
		local x1,y1 = getElementPosition(source)
		local dist = getDistanceBetweenPoints2D(x,y,x1,y1)
		local isMarkerSafe = isElementWithinMarker(vh,MarkerSafeEntregadorDeJornal)
		local id = getElementModel(vh)
		local seat = getPedOccupiedVehicleSeat(source)
		if dist > 0 then return end
		if id == 510 then		
			if seat == 0 then
				if isMarkerSafe == false then return end
				triggerClientEvent(source,"Hype>JOBEntregadorDeJornal>AbrirPainel<Client",source,rotasJORNAL)
			end
		end
	end
end
end
addCommandHandler("rotas",pickjobJornal)

function receivert(source,rotaname)
	if isElement(ppcikJORNAL[source]) then
		destroyElement(ppcikJORNAL[source])
	end	
	triggerClientEvent(source,"Hype>JOBEntregadorDeJornal>blips<Client",source,false)
	setElementData(source,"rtnameJornal",rotaname)
	atualrotnumberJORNAL[source] = 1
	gerarrota(source)
end
addEvent("Hype>request>Startrota>Server>EntregadorDeJornal", true)
addEventHandler("Hype>request>Startrota>Server>EntregadorDeJornal",getRootElement(), receivert)

function gerarrota(source)
	local rname = getElementData(source,"rtnameJornal") or nil
	if rname == nil then return end
	if not isElement(ppcikJORNAL[source]) and isPedInVehicle(source) then
		local vh = getPedOccupiedVehicle(source)
		toggleAllControls ( source, true )
		setControlState ( source, "handbrake", false )
		local id = tonumber(atualrotnumberJORNAL[source])
		local x,y,z = rotasJORNAL[rname][id][1],rotasJORNAL[rname][id][2],rotasJORNAL[rname][id][3]
		ppcikJORNAL[source] = createMarker (x, y,z, "checkpoint", 4, 255, 0, 0, 50,source)
		triggerClientEvent(source,"Hype>JOBEntregadorDeJornal>blips<Client",source,true,x,y,z)
		atualrotnumberJORNAL[source] = id+1
	end
end

function sair ( quitType )
	if isElement(ppcikJORNAL[source]) then
		destroyElement(ppcikJORNAL[source])
	end
end
addEventHandler ( "onPlayerQuit", getRootElement(), sair )

function SairDaBike ( thePlayer, seat, jacked )
   local rname = getElementData(thePlayer,"rtnameJornal") or nil
   if rname == nil then return end
   canceljobtimer (thePlayer)
   exports.Hype_MensagemDX:outputDx(thePlayer, "Você Saiu da Bike, Entregas Canceladas!", "warning")
end
addEventHandler ( "onVehicleExit", getRootElement(), SairDaBike )

function canceljobtimer(source)
	if isElement(ppcikJORNAL[source]) then
		destroyElement(ppcikJORNAL[source])
	end	
	triggerClientEvent(source,"Hype>JOBEntregadorDeJornal>blips<Client",source,false)	
	atualrotnumberJORNAL[source] = 1
	setElementData(source,"rtnameJornal",nil)	
end

function canceljobdeath()
	local job = getElementData(source,"Emprego") or false
	if job ~= "Entregador de Jornal" then return end
	local rname = getElementData(source,"rtnameJornal") or nil
	if rname == nil then return end
	canceljobtimer(source)
	exports.Hype_MensagemDX:outputDx(source, "Você Morreu e Suas Entregas Foram Canceladas!", "warning")
end	
addEventHandler( "onPlayerWasted", getRootElement( ),canceljobdeath)