--------------------------------------------------------------------

PetroleiroPickup = createPickup ( 283.75128, 1432.13159, 10.79398, 3, 1210)
MarkerPetroleiro = createMarker ( 283.75128, 1432.13159, 10.79398, "cylinder", 1.2, 255, 255, 255, 0 )
attachElements ( MarkerPetroleiro, PetroleiroPickup, 0, 0, -1 )
BlipPetroleiro = createBlipAttachedTo ( MarkerPetroleiro, 42 )
setBlipVisibleDistance ( BlipPetroleiro, 150 )

safe = createMarker ( 192.2998046875, 1400.599609375, 9, "cylinder", 11, 0, 255, 0, 0)

function CancelarSumirPickup ( player )
   cancelEvent()
end
addEventHandler ( "onPickupHit", PetroleiroPickup, CancelarSumirPickup )

--------------------------------------------------------------------

LetraParaMarkers = "k"
cmd1 = "hq"
cmd2 = "profissao"

--------------------------------------------------------------------

local HQPetroleiroBlip = createBlip ( 270.59879, 1409.27441, 10.46635 )
setElementVisibleTo ( HQPetroleiroBlip, root, false )

--------------------------------------------------------------------

function VerificarBlipEmprego(player)
  if player then
  acc = getPlayerAccount ( player )
  if isGuestAccount ( acc ) then return end
  setElementVisibleTo ( HQPetroleiroBlip, player, false )
  end
end

setTimer(
function()
	for i, pl in pairs(getElementsByType("player")) do
		if pl ~= (false or nil) then
		    if getElementData ( pl, "Emprego" ) == "Petroleiro" then return end
			   VerificarBlipEmprego(pl)
		end
	end
end,
3000,0)

--------------------------------------------------------------------

function ComandoHQ ( source )
    if getElementData ( source, "Emprego" ) == "Petroleiro" then
	if isElementVisibleTo ( HQPetroleiroBlip, source ) then
	setElementVisibleTo ( HQPetroleiroBlip, source, false )
	exports.Hype_MensagemDX:outputDx(source, "Seu Local de Trabalho foi Desmarcado do Mapa!", "info")
	else
	setElementVisibleTo ( HQPetroleiroBlip, source, true )
	exports.Hype_MensagemDX:outputDx(source, "Seu Local de Trabalho foi Marcado no Mapa!", "info")
end
end	
end    
addCommandHandler ( cmd1, ComandoHQ )

--------------------------------------------------------------------

function AceitarEmprego02 (source)
exports.Hype_MsgsMarker:delete(source)
unbindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
if getElementData ( source, "Hype>Encaminhamento" ) == "Petroleiro" then
setElementData ( source, "Hype>Encaminhamento", false )
setElementData ( source, "Emprego", "Petroleiro" )
exports.Hype_MensagemDX:outputDx(source, "Você Agora Trabalha de Petroleiro, Para Mais Informações Digite ( /Profissao )", "success")
else
exports.Hype_MensagemDX:outputDx(source, "Você Precisa Estar Encaminhado da Agencia de Empregos para Trabalhar neste Local!", "error")
end
end

function RecusarEmprego02 (source)
exports.Hype_MsgsMarker:delete(source)
unbindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
if isElementVisibleTo ( HQPetroleiroBlip, source ) then
setElementVisibleTo ( HQPetroleiroBlip, source, false )
end
removeElementData ( source, "Emprego", "Petroleiro" )
exports.Hype_MensagemDX:outputDx(source, "Você se Demitiu do Emprego de Petroleiro com Sucesso!", "warning")
end

--------------------------------------------------------------------

function ComandosProf ( ThePlayer )
if getElementData ( ThePlayer, "Emprego" ) == "Petroleiro" then
playSoundFrontEnd ( ThePlayer, 43 )
outputChatBox ( "#F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #F96031Profissão #F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #BEE09AComandos da Profissão de Petroleiro", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #55D444/HQ #ffffff- #9ABDE0Para Marcar / Desmarcar o seu Local de Trabalho", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #FFD700Entre no Caminhão e Dirija até a Area de Carregamento", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #FFD700Na Area de Carregamento Aperte a Letra 'K' Para Carregar!", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #F96031Profissão #F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~", ThePlayer, 255, 255, 255, true )
end
end
addCommandHandler(cmd2, ComandosProf )

--------------------------------------------------------------------

function emarker(marker,md) 
	if (md) then
	  if not isPedInVehicle ( source ) then
		if marker == MarkerPetroleiro then
		    if getElementData ( source, "Emprego" ) == "Petroleiro" then
			exports.Hype_MsgsMarker:create(source,"Aperte 'K' Para se Demitir do Emprego de Petroleiro")
			bindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
		else
			exports.Hype_MsgsMarker:create(source,"Aperte 'K' Para Aceitar o Emprego de Petroleiro")
			bindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
		end
		end
		end
		local seat = getPedOccupiedVehicleSeat ( source )
	    if seat == 0 then
		if marker == safe then
			bindKey ( source, LetraParaMarkers, "down", pickjobonbus )
			exports.Hype_MsgsMarker:create(source,"Aperte 'K' Para Carregar o Seu Caminhão")
		end
		if marker == ppcik[source] then
			bindKey ( source, LetraParaMarkers, "down", ifPlayerEnterOnMarker )
			exports.Hype_MsgsMarker:create(source,"Aperte 'K' Para Descarregar o Seu Caminhão")
        end
	  end
  end	
end
addEventHandler("onPlayerMarkerHit",getRootElement(),emarker)

function lmarker(marker,md)
	if (md) then
		if marker == MarkerPetroleiro then
			exports.Hype_MsgsMarker:delete(source)			
			unbindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
			unbindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
		end
		if marker == safe then
			unbindKey ( source, LetraParaMarkers, "down", pickjobonbus )
			exports.Hype_MsgsMarker:delete(source)
		end
		if marker == ppcik[source] then
			unbindKey ( source, LetraParaMarkers, "down", ifPlayerEnterOnMarker )
			exports.Hype_MsgsMarker:delete(source)
		end
	end
end
addEventHandler("onPlayerMarkerLeave",getRootElement(),lmarker)

--------------------------------------------------------------------

atualrotnumber = {}
ppcik = {}
blips = {}

--------------------------------------------------------------------

V_01 = 260
V_02 = 420
V_03 = 2200
V_04 = 2600
V_05 = 3800
V_06 = 6200
V_07 = 3800
V_08 = 2200
V_09 = 1400
V_10 = 5000
V_11 = 5000
V_12 = 8600
V_13 = 8600
V_14 = 6600
V_15 = 9900
V_16 = 9800
V_17 = 7400
V_18 = 6360

rotas = {
	["Posto de Fort Carson - $"..V_01..""] = {
		{70.36392, 1218.65625, 18.81190},
	},
	["Posto de Bone County - $"..V_02..""] = {
		{612.14429, 1695.00281, 6.99219},
	},
	["Posto de Tierra Robada - $"..V_03..""] = {
	    {-1477.12805, 1863.58386, 32.63281},
	},
	["Posto de Tierra Robada II - $"..V_04..""] = {
	    {-1328.97241, 2672.06689, 50.06250},
	},
	["Posto de Redsands West - $"..V_05..""] = {
	    {1595.82605, 2198.85205, 10.82031},
	},
	["Posto de Spinybed - $"..V_06..""] = {
	    {2147.65674, 2747.65161, 10.82031},
	},
	["Posto de The Emerald Isle - $"..V_07..""] = {
	    {2202.37598, 2474.13965, 10.82031},
	},
	["Posto de Las Venturas - $"..V_08..""] = {
	    {2639.75928, 1106.16931, 10.82031},
	},
	["Posto de Las Venturas II - $"..V_09..""] = {
	    {2115.28882, 920.22015, 10.82031},
	},
	["Posto de Montgomery - $"..V_10..""] = {
	    {1382.29285, 460.14056, 20.34520},
	},
	["Posto de Dillimore - $"..V_11..""] = {
	    {654.96869, -559.74841, 16.50149},
	},
	["Posto de Temple - $"..V_12..""] = {
	    {1004.65613, -936.75317, 42.32813},
	},
	["Posto de Idlewood - $"..V_13..""] = {
	    {1942.37158, -1772.88501, 13.64063},
	},
	["Posto de Flint County - $"..V_14..""] = {
	    {-93.53500, -1174.47327, 2.28485},
	},
	["Posto de Whetstone - $"..V_15..""] = {
	    {-1605.74585, -2714.55273, 48.53347},
	},
	["Posto de Angel Pine - $"..V_16..""] = {
	    {-2244.26880, -2561.07104, 31.92188},
	},
	["Posto de Juniper Hallow - $"..V_17..""] = {
	    {-2410.03662, 976.18658, 45.42539},
	},
	["Posto de Easter Basin - $"..V_18..""] = {
	    {-1675.65918, 413.23929, 7.17969},
	},
}

--------------------------------------------------------------------

pay={["Posto de Fort Carson - $"..V_01..""] = V_01,
     ["Posto de Bone County - $"..V_02..""] = V_02,
	 ["Posto de Tierra Robada - $"..V_03..""] = V_03,
	 ["Posto de Tierra Robada II - $"..V_04..""] = V_04,
	 ["Posto de Redsands West - $"..V_05..""] = V_05,
	 ["Posto de Spinybed - $"..V_06..""] = V_06,
	 ["Posto de The Emerald Isle - $"..V_07..""] = V_07,
	 ["Posto de Las Venturas - $"..V_08..""] = V_08,
	 ["Posto de Las Venturas II - $"..V_09..""] = V_09,
	 ["Posto de Montgomery - $"..V_10..""] = V_10,
	 ["Posto de Dillimore - $"..V_11..""] = V_11,
	 ["Posto de Temple - $"..V_12..""] = V_12,
	 ["Posto de Idlewood - $"..V_13..""] = V_13,
	 ["Posto de Flint County - $"..V_14..""] = V_14,
	 ["Posto de Whetstone - $"..V_15..""] = V_15,
	 ["Posto de Angel Pine - $"..V_16..""] = V_16,
	 ["Posto de Juniper Hallow - $"..V_17..""] = V_17,
	 ["Posto de Easter Basin - $"..V_18..""] = V_18,
}

--------------------------------------------------------------------

function receivert(source,rotaname)
 if isElement(ppcik[source]) then
  destroyElement(ppcik[source])
 end	
 triggerClientEvent(source,"JOBUS>blips<Client",source,false)
 setElementData(source,"rtname",rotaname)
 atualrotnumber[source] = 1
 gerarrota(source)
end
addEvent("request>Startrota>Server", true)
addEventHandler("request>Startrota>Server",getRootElement(), receivert)

--------------------------------------------------------------------

function ifPlayerEnterOnMarker ( source )
if isPedInVehicle(source) then
    if not isElementWithinMarker(source, ppcik[source]) then return end
		if isElement(ppcik[source]) then
		local vh = getPedOccupiedVehicle(source)
		local id = getElementModel(vh)
			if id == 514 then
			    if ( getVehicleTowedByVehicle ( vh ) == CargaPet[source] ) then
			    local rname = getElementData(source,"rtname") or nil
			        if rname == nil then return end
				    destroyElement(ppcik[source])
				    triggerClientEvent(source,"JOBUS>blips<Client",source,false)		
				        if atualrotnumber[source] <= #rotas[rname] then
					    gerarrota(source)
				            elseif atualrotnumber[source] == #rotas[rname]+1 then
					        setElementData(source,"rtname",rname)
					        atualrotnumber[source] = 1
					        local rec = pay[rname]
					        givePlayerMoney(source,tonumber(rec))	
					        local vh = getPedOccupiedVehicle(source)
					        destroyElement ( CargaPet[source] )	
					        setElementData(source,"rtname",nil)
							exports.Hype_MensagemDX:outputDx(source, "Sua Carreta foi Descarregada, e Você Recebeu $"..rec.." Pelo Serviço!", "success")
							
							setElementData ( source, "HypeSCR_LiberarXP", "Sim" )
							
							unbindKey ( source, LetraParaMarkers, "down", ifPlayerEnterOnMarker )
			                exports.Hype_MsgsMarker:delete(source)
							
				        end
	            else
				exports.Hype_MensagemDX:outputDx(source, "Você Não pode Descarregar seu Caminhão sem Sua Carga!", "error")
                end
            end
        end
    end
end

--------------------------------------------------------------------

function pickjobonbus(source)
	if not isElement(source) then return end
	
	local im = isPedInVehicle(source)
	if im == false then return end	
	
	local job = getElementData(source,"Emprego") or false
	if job == false or job == nil then
	exports.Hype_MensagemDX:outputDx(source, "Você Não é um Petroleiro, Portanto não Podera usar Esse Comando!", "error") return end
	if job == "Petroleiro" then
	
	local vh = getPedOccupiedVehicle(source)
	if isElement(vh) then
	local x,y = getElementPosition(vh)
	local x1,y1 = getElementPosition(source)
	local dist = getDistanceBetweenPoints2D(x,y,x1,y1)
	local issafe = isElementWithinMarker(vh,safe)
	local id = getElementModel(vh)
	local seat = getPedOccupiedVehicleSeat(source)
		if dist > 0 then return end
		    if id == 514 then		
			    if seat == 0 then
		        local speedX, speedY, speedZ = getElementVelocity ( vh  )
	            local actualSpeed = (speedX^2 + speedY^2 + speedZ^2)^(0.5) 
	            local KMH = math.floor(actualSpeed*180)
			        if KMH >= 1 then
					exports.Hype_MensagemDX:outputDx(source, "Pare o Caminhão Para Poder Carregar!", "warning") return end
				        if issafe == false then return end
			            
						unbindKey ( source, LetraParaMarkers, "down", pickjobonbus )
			            exports.Hype_MsgsMarker:delete(source)
				        
						triggerClientEvent(source,"JOBUS>AbrirPainel<Client",source,rotas)
                end
            end
        end
    end
end

--------------------------------------------------------------------

--[[function setPlayerBlipColor( thePlayer , r, g, b ,a) 
	if not a then
	a = 255
	end
    local blips = getElementsByType( "blip" ) 
	
    for k, theBlip in ipairs( blips ) do 
    if getElementAttachedTo( theBlip ) == thePlayer then 
    setBlipColor ( theBlip, r, g, b ,a )
    end 
    end 
end --]]

CargaPet = {}

function gerarrota(source)
	
	local rname = getElementData(source,"rtname") or nil
	if rname == nil then return end
	
	if not isElement(ppcik[source]) and isPedInVehicle(source) then
	
	local vh = getPedOccupiedVehicle(source)
	local id = tonumber(atualrotnumber[source])
	local x,y,z = rotas[rname][id][1],rotas[rname][id][2],rotas[rname][id][3]
	
	ppcik[source] = createMarker (x, y,z, "checkpoint", 5, 255, 0, 0, 50,source)
	triggerClientEvent(source,"JOBUS>blips<Client",source,true,x,y,z)
	atualrotnumber[source] = id+1
		
	local vh = getPedOccupiedVehicle(source)
	local xe,ye,ze = getElementPosition ( source )
	
	if CargaPet[source] and isElement( CargaPet[source] ) then
	destroyElement ( CargaPet[source] )
	CargaPet[source] = nil
	end
	
	CargaPet[source] = createVehicle ( 584, xe,ye,ze +15 )
	setTimer ( attachTrailerToVehicle, 50, 1, vh, CargaPet[source] )
	setTimer ( attachTrailerToVehicle, 1000, 1, vh, CargaPet[source] )
	setTimer ( attachTrailerToVehicle, 5000, 1, vh, CargaPet[source] )
	
	exports.Hype_MensagemDX:outputDx(source, "Sua Carreta foi Carregada, Siga o Icone Marcado no Mapa Para Descarregar sua Carga!", "info")
	
end
end

--------------------------------------------------------------------

function sair ( quitType )
 if isElement(ppcik[source]) then
  destroyElement(ppcik[source])
 end
 if isElement( CargaPet[source] ) then
  destroyElement ( CargaPet[source] )
 end
end
addEventHandler ( "onPlayerQuit", getRootElement(), sair )

--------------------------------------------------------------------

function removeHelmetOnExit ( thePlayer, seat, jacked )
	local job = getElementData(thePlayer,"Emprego") or false
	if job ~= "Petroleiro" then return end
	local rname = getElementData(thePlayer,"rtname") or nil
	if rname == nil then return end
    if ( getElementModel ( source ) == 514 ) then 
    canceljobtimer (thePlayer)
    end
end
addEventHandler ( "onVehicleExit", getRootElement(), removeHelmetOnExit )

--------------------------------------------------------------------

function SairDoCaminhao ( thePlayer, seat, jacked )
   local rname = getElementData(thePlayer,"rtname") or nil
   if rname == nil then return end
   canceljobtimer (thePlayer)
   exports.Hype_MensagemDX:outputDx(thePlayer, "Você Saiu do Caminhão e Sua Carga foi Destruida!", "warning")
end
addEventHandler ( "onVehicleExit", getRootElement(), SairDoCaminhao )

--------------------------------------------------------------------
   
function canceljobtimer(source)
 if isElement(ppcik[source]) then
  destroyElement(ppcik[source])
 end	
 triggerClientEvent(source,"JOBUS>blips<Client",source,false)	
 atualrotnumber[source] = 1
 setElementData(source,"rtname",nil)
 if isElement( CargaPet[source] ) then
  destroyElement ( CargaPet[source] )
 end
end

--------------------------------------------------------------------

function canceljobdeath()
	local job = getElementData(source,"Emprego") or false
	if job ~= "Petroleiro" then return end
	local rname = getElementData(source,"rtname") or nil
	if rname == nil then return end
	canceljobtimer(source)
	DestruirPetroleiroVeiculo(source)
	exports.Hype_MensagemDX:outputDx(source, "Você Morreu e Sua Carga foi Destruida!", "warning")
	end
addEventHandler( "onPlayerWasted", getRootElement( ),canceljobdeath)

--------------------------------------------------------------------

local vehiclesToSpawn =
{
	{ 514, 282.71198, 1389.41418, 11.35385, 90 },
	{ 514, 282.71198, 1384.41418-3, 11.35385, 90 },
	{ 514, 282.71198, 1379.41418-6, 11.35385, 90 },
}

local vehicleDestroyTimers = {}
local playerVehicles = {}

local function destroyPlayerVehicles()
	local vehicles = playerVehicles[source]
	for _,vehicle in ipairs(vehicles) do
		if isElement(vehicle) then
			destroyElement(vehicle)
		end
	end
	playerVehicles[source] = nil
end

local function onEnter(player)
	local t = tonumber(get("vehicleRespawnTime")) or 60000
	source.damageProof = false
	source.frozen = false
	local vehicledata = vehiclesToSpawn[source]
	setTimer(createNewVehicle,(t > 50 and t or 50),1,vehicledata)
	vehiclesToSpawn[source] = nil
	if not playerVehicles[player] then
		playerVehicles[player] = {}
		addEventHandler("onPlayerQuit",player,destroyPlayerVehicles)
	end
	table.insert(playerVehicles[player],source)
	removeEventHandler("onVehicleEnter",source,onEnter)
end

local function destroyVehicle(vehicle)
	if vehicle and isElement(vehicle) and getElementType(vehicle) == "vehicle" then
		destroyElement(vehicle)
	end
end

local function destroyTimer()
	if vehicleDestroyTimers[source] and isTimer(vehicleDestroyTimers[source]) then killTimer(vehicleDestroyTimers[source]) end
	removeEventHandler("onVehicleEnter",source,destroyTimer)
end

local function onExit()
	local t = tonumber(get("vehicleExpireTime")) or 600000
	vehicleDestroyTimers[source] = setTimer(destroyVehicle,(t > 50 and t or 50),1,source)
	addEventHandler("onVehicleEnter",source,destroyTimer)
end

function VerificarEmprego ( thePlayer, seat )
    local Jogador = getElementData ( thePlayer, "Emprego" )
    if seat == 0 then
        if Jogador == "Petroleiro" then
		    -- Entra no Veiculo (OK!)
		else
            cancelEvent ( )
            exports.Hype_MensagemDX:outputDx ( thePlayer, "Veiculo Exclusivo de Profissão!", "error" )
		end
    end
end

function createNewVehicle(vehicledata)
	local m,x,y,z,r = unpack(vehicledata)
	local vehicle = Vehicle(m,x,y,z,0,0,r)
	vehicle.damageProof = true
	vehicle.frozen = true
	vehiclesToSpawn[vehicle] = vehicledata
	addEventHandler("onVehicleEnter",vehicle,onEnter)
	addEventHandler("onVehicleExit",vehicle,onExit)
	addEventHandler("onVehicleStartEnter",vehicle,VerificarEmprego )
end

local function initScript()
	for _,vehicledata in ipairs(vehiclesToSpawn) do createNewVehicle(vehicledata) end
end
addEventHandler("onResourceStart",resourceRoot,initScript)