
FabricadorPickup = createPickup ( -509.26321411133,2588.1435786875,53.415424346924, 3, 1210 )
MarkerFabricador = createMarker ( -509.26321411133,2588.1435786875,53.415424346924, "cylinder", 1.2, 255, 255, 255, 0 )
attachElements ( MarkerFabricador, FabricadorPickup, 0, 0, -1 )
BlipFabricador = createBlipAttachedTo ( MarkerFabricador, 42 )
setBlipVisibleDistance ( BlipFabricador, 150 )

function CancelarSumirPickup ( player )
   cancelEvent ( )
end
addEventHandler ( "onPickupHit", FabricadorPickup, CancelarSumirPickup )

LetraParaMarkers = "K"
cmd1 = "hq"
cmd2 = "profissao"

local HQFabricadorBlip = createBlip ( -509.26321411133,2588.1435786875,53.415424346924 )
setElementVisibleTo ( HQFabricadorBlip, root, false )

function VerificarBlipEmprego(player)
    if player then
        acc = getPlayerAccount ( player )
        if isGuestAccount ( acc ) then return end
        setElementVisibleTo ( HQFabricadorBlip, player, false )
    end
end

setTimer(
function()
	for i, pl in pairs(getElementsByType("player")) do
		if pl ~= (false or nil) then
		    if getElementData ( pl, "Emprego" ) == "Fabricador De Armas" then return end
		    VerificarBlipEmprego(pl)
		end
	end
end,
3000,0)

function ComandoHQ ( source )
    if getElementData ( source, "Emprego" ) == "Fabricador De Armas" then
	    if isElementVisibleTo ( HQFabricadorBlip, source ) then
	        setElementVisibleTo ( HQFabricadorBlip, source, false )
	        exports.Hype_MensagemDX:outputDx(source, "Seu Local de Trabalho foi Desmarcado do Mapa!", "info")
	    else
	        setElementVisibleTo ( HQFabricadorBlip, source, true )
	        exports.Hype_MensagemDX:outputDx(source, "Seu Local de Trabalho foi Marcado no Mapa!", "info")
        end
    end	
end    
addCommandHandler ( cmd1, ComandoHQ )

function AceitarEmprego02 (source)
    exports.Hype_MsgsMarker:delete(source)
    unbindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
    if getElementData ( source, "Hype>Encaminhamento" ) == "Fabricador De Armas" then
        setElementData ( source, "Hype>Encaminhamento", false )
        setElementData ( source, "Emprego", "Fabricador De Armas" )
        exports.Hype_MensagemDX:outputDx(source, "Você Agora Trabalha de Fabricador De Armas, Para Mais Informações Digite ( /Profissao )", "success")
    else
        exports.Hype_MensagemDX:outputDx(source, "Você Precisa Estar Encaminhado da Agencia de Empregos para Trabalhar neste Local!", "error")
    end
end

function RecusarEmprego02 (source)
    exports.Hype_MsgsMarker:delete(source)
    unbindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
    if isElementVisibleTo ( HQFabricadorBlip, source ) then
        setElementVisibleTo ( HQFabricadorBlip, source, false )
    end
    removeElementData ( source, "Emprego", "Fabricador De Armas" )
    exports.Hype_MensagemDX:outputDx(source, "Você se Demitiu do Emprego de Fabricador De Armas com Sucesso!", "warning")
end

function ComandosProf ( ThePlayer )
    if getElementData ( ThePlayer, "Emprego" ) == "Fabricador De Armas" then
        playSoundFrontEnd ( ThePlayer, 43 )
        outputChatBox ( "#F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #F96031Profissão #F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~", ThePlayer, 255, 255, 255, true )
        outputChatBox ( "#F96031» #BEE09AComandos da Profissão de Fabricador De Armas", ThePlayer, 255, 255, 255, true )
        outputChatBox ( "#F96031» #55D444/HQ #ffffff- #9ABDE0Para Marcar / Desmarcar o seu Local de Trabalho", ThePlayer, 255, 255, 255, true )
        outputChatBox ( "#F96031» #FFD700Entre no Caminhão e Digite /Carregar", ThePlayer, 255, 255, 255, true )
        outputChatBox ( "#F96031» #FFD700Selecione a Rota e Vá para a Entrega com o Caminhão!", ThePlayer, 255, 255, 255, true )
        outputChatBox ( "#F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #F96031Profissão #F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~", ThePlayer, 255, 255, 255, true )
    end
end
addCommandHandler ( cmd2, ComandosProf )

function emarker ( marker, md ) 
    if md then
        if not isPedInVehicle ( source ) then
            if marker == MarkerFabricador then
                if getElementData ( source, "Emprego" ) == "Fabricador De Armas" then
			        exports.Hype_MsgsMarker:create(source,"Aperte 'K' Para se Demitir do Emprego de Fabricador De Armas")
			        bindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
		        else
			        exports.Hype_MsgsMarker:create(source,"Aperte 'K' Para Aceitar o Emprego de Fabricador De Armas")
			        bindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
		        end
		    end
		end
	end
end
addEventHandler ( "onPlayerMarkerHit", getRootElement ( ), emarker )

function lmarker ( marker, md )
	if md then
		if marker == MarkerFabricador then
			exports.Hype_MsgsMarker:delete(source)			
			unbindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
			unbindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
		end
	end
end
addEventHandler ( "onPlayerMarkerLeave", getRootElement ( ), lmarker )

----------------------------------------------------------------------------------------------------------------

local Marker_Carregamento_Peketo = createMarker ( -558.98431396484,2601.22265625,54.196083068848 -1, "cylinder", 50, 255, 255, 255, 0 )

ObjetoID = 1558
Tempo_Para_Coletar_Arma = 20000 -- 5 Segundos
R_MK, G_MK, B_MK, A_MK = 255, 0, 0, 120
Veiculo_Emprego_ID = 578

Caixa_01 = {}
Caixa_02 = {}
Caixa_03 = {}
Caixa_04 = {}
Caixa_05 = {}
Caixa_06 = {}
Caixa_07 = {}
Caixa_08 = {}
Caixa_09 = {}
Caixa_10 = {}
Caixa_11 = {}
Caixa_12 = {}
Caixa_13 = {}
Caixa_14 = {}

T1_MK, T2_MK, R_MK, G_MK, B_MK, A_MK = "cylinder", 7, 255, 0, 0, 255

local Marker_Entrega_Final_LV_01 = createMarker ( 1360.9536132813,-1279.7564697266,13.3828125 -1, T1_MK, T2_MK, R_MK, G_MK, B_MK, A_MK )
local Bliper_Entrega_Final_LV_01 = createBlipAttachedTo ( Marker_Entrega_Final_LV_01, 0 )
setElementVisibleTo ( Marker_Entrega_Final_LV_01, root, false )
setElementVisibleTo ( Bliper_Entrega_Final_LV_01, root, false )
-- LVA Freight Depot, Las Venturas -- 1841.5396728516

local Marker_Entrega_Final_BS_01 = createMarker ( 1535.8259277344,-1677.9993896484,13.3828125 -1, T1_MK, T2_MK, R_MK, G_MK, B_MK, A_MK )
local Bliper_Entrega_Final_BS_01 = createBlipAttachedTo ( Marker_Entrega_Final_BS_01, 0 )
setElementVisibleTo ( Marker_Entrega_Final_BS_01, root, false )
setElementVisibleTo ( Bliper_Entrega_Final_BS_01, root, false )
-- Bayside, Tierra Robada -- 3317.3039550781

local Marker_Entrega_Final_MC_01 = createMarker ( -1582.2673339844,673.35162353516,7.1875 -1, T1_MK, T2_MK, R_MK, G_MK, B_MK, A_MK )
local Bliper_Entrega_Final_MC_01 = createBlipAttachedTo ( Marker_Entrega_Final_MC_01, 0 )
setElementVisibleTo ( Marker_Entrega_Final_MC_01, root, false )
setElementVisibleTo ( Bliper_Entrega_Final_MC_01, root, false )
-- Angel Pine, Whetstone -- 3192.1362304688

local Marker_Entrega_Final_LS_01 = createMarker ( -2625.1733398438,214.49925231934,4.4909796714783 -1, T1_MK, T2_MK, R_MK, G_MK, B_MK, A_MK )
local Bliper_Entrega_Final_LS_01 = createBlipAttachedTo ( Marker_Entrega_Final_LS_01, 0 )
setElementVisibleTo ( Marker_Entrega_Final_LS_01, root, false )
setElementVisibleTo ( Bliper_Entrega_Final_LS_01, root, false )
-- Temple, Los Santos -- 1457.4808349609

local Marker_Entrega_Final_LV_02 = createMarker ( 780.90344238281,1877.6488037109,4.9429955482483 -1, T1_MK, T2_MK, R_MK, G_MK, B_MK, A_MK )
local Bliper_Entrega_Final_LV_02 = createBlipAttachedTo ( Marker_Entrega_Final_LV_02, 0 )
setElementVisibleTo ( Marker_Entrega_Final_LV_02, root, false )
setElementVisibleTo ( Bliper_Entrega_Final_LV_02, root, false )
-- Redsands West, Las Venturas -- 2890.8366699219

local Marker_Entrega_Final_51_01 = createMarker ( 2290.193359375,2415.5600585938,10.785322189331 -1, T1_MK, T2_MK, R_MK, G_MK, B_MK, A_MK )
local Bliper_Entrega_Final_51_01 = createBlipAttachedTo ( Marker_Entrega_Final_51_01, 0 )
setElementVisibleTo ( Marker_Entrega_Final_51_01, root, false )
setElementVisibleTo ( Bliper_Entrega_Final_51_01, root, false )
-- Fort Carson, Bone County -- 1022.3161621094

local Marker_Entrega_Final_SF_01 = createMarker ( -1723.9545898438,-120.0316619873,3.5489187240601 -1, T1_MK, T2_MK, R_MK, G_MK, B_MK, A_MK )
local Bliper_Entrega_Final_SF_01 = createBlipAttachedTo ( Marker_Entrega_Final_SF_01, 0 )
setElementVisibleTo ( Marker_Entrega_Final_SF_01, root, false )
setElementVisibleTo ( Bliper_Entrega_Final_SF_01, root, false )
-- Easter Bay Airport, San Fierro -- 1678.5166015625

local Marker_Entrega_Final_SF_02 = createMarker ( -2796.0739746094,775.25415039063,50.328838348389 -1, T1_MK, T2_MK, R_MK, G_MK, B_MK, A_MK )
local Bliper_Entrega_Final_SF_02 = createBlipAttachedTo ( Marker_Entrega_Final_SF_02, 0 )
setElementVisibleTo ( Marker_Entrega_Final_SF_02, root, false )
setElementVisibleTo ( Bliper_Entrega_Final_SF_02, root, false )
-- Palisades, San Fierro -- 2852.9958496094

local Marker_Entrega_Final_LS_02 = createMarker ( 2262.1865234375,-1969.7722167969,13.353647232056 -1, T1_MK, T2_MK, R_MK, G_MK, B_MK, A_MK )
local Bliper_Entrega_Final_LS_02 = createBlipAttachedTo ( Marker_Entrega_Final_LS_02, 0 )
setElementVisibleTo ( Marker_Entrega_Final_LS_02, root, false )
setElementVisibleTo ( Bliper_Entrega_Final_LS_02, root, false )
-- Willowfield, Los Santos -- 3039.326171875



function onMrWhoopeeEnter ( source )
    if getElementData ( source, "Emprego" ) == "Fabricador De Armas" then
        if isPedInVehicle ( source ) then
            --local PosX, PosY, PosZ = getElementPosition ( source )
	        local vh = getPedOccupiedVehicle ( source )
	        if isElement ( vh ) then
			    local ID = getElementModel ( vh )
				if ID == 578 then
				    local seat = getPedOccupiedVehicleSeat ( source )
				    if seat == 0 then
				        local X_VEH, Y_VEH = getElementPosition ( vh )
		                local X_PLAYER, Y_PLAYER = getElementPosition ( source )
		                local Distancia = getDistanceBetweenPoints2D ( X_VEH, Y_VEH, X_PLAYER, Y_PLAYER )
					    if Distancia > 0 then return end
					    if isElementWithinMarker ( vh, Marker_Carregamento_Peketo ) then
					        local Arma_Total = getElementData ( source, "Peketo_ArmaColetado" ) or 0
					        if Arma_Total > 0 then
					    	    --outputChatBox ( "* Leve o Carregamento para uma das Empresas Marcadas no seu Mapa!", source )
					    	    --setVisibleEmpresas ( source, true )
					    	    --setElementData ( vh, "Peketo_Carregado", getPlayerName ( source ) )
					    	    --setVisibleEmpresas ( source, false, "Finalizar" )
					    	    triggerClientEvent ( source, "Peketo_Fabricador_Abrir", root )
					    	else
					    	    Mensagem_Peketo ( source, "Erro: Você não possui Armas para Carregar seu Caminhão!", "error" )
					    	end
    				    end
					end
    			end
    		end
		end
	end
end
addCommandHandler ( "carregar", onMrWhoopeeEnter )

function Sair_do_Veiculo ( thePlayer, seat, jacked )
    if getElementData ( thePlayer, "Emprego" ) == "Fabricador De Armas" then
	    local Rota = getElementData ( thePlayer, "Peketo_Fabricador_Para" ) or nil
	    if Rota == "01" or Rota == "02" or Rota == "03" or Rota == "04" or Rota == "05" or Rota == "06" or Rota == "07" or Rota == "08" or Rota == "09" then
	        setElementData ( thePlayer, "Peketo_Fabricador_Para", "00" )
			outputChatBox ( "* Fábrica: Você saiu do Veiculo e Perdeu o Carregamento de Armas!", thePlayer, 255, 255, 255, true )
			setVisibleEmpresas ( thePlayer, false, "Finalizar" )
		end
	end
end
addEventHandler ( "onVehicleExit", getRootElement(), Sair_do_Veiculo )

--------------- // --------------- --------------- // --------------- --------------- // --------------

local Vaca01_Estado = false
local Vaca01_Marker = createMarker ( -575.03570556641,2611.0493164063,53.515625 -1, "cylinder", 1.2, R_MK, G_MK, B_MK, A_MK )
local Vaca01 = createObject ( 3383, -576.07244873047,2611.0354003906,52.515625, 0, 0, -90 )
local Arma = createObject ( 356, -575.88653564453,2610.9829101563,53.515625, 90, 0, -90 )
setObjectScale ( Vaca01, 0.8 )
setElementCollisionsEnabled ( Vaca01, false )

local Vaca02_Estado = false
local Vaca02_Marker = createMarker ( -575.03570556641,2605.0493164063,53.515625 -1, "cylinder", 1.2, R_MK, G_MK, B_MK, A_MK )
local Vaca02 = createObject ( 3383, -576.07244873047,2605.0354003906,52.515625, 0, 0, -90 )
local Arma2 = createObject ( 356, -575.88653564453,2604.9829101563,53.515625, 90, 0, -90 )
setObjectScale ( Vaca02, 0.8 )
setElementCollisionsEnabled ( Vaca02, false )

local Vaca03_Estado = false
local Vaca03_Marker = createMarker ( -575.03570556641,2599.0493164063,53.515625 -1, "cylinder", 1.2, R_MK, G_MK, B_MK, A_MK )
local Vaca03 = createObject ( 3383, -576.07244873047,2599.0354003906,52.515625, 0, 0, -90 )
local Arma3 = createObject ( 356, -575.88653564453,2598.9829101563,53.515625, 90, 0, -90 )
setObjectScale ( Vaca03, 0.8 )
setElementCollisionsEnabled ( Vaca03, false )

local Vaca04_Estado = false
local Vaca04_Marker = createMarker ( -575.03570556641,2593.0493164063,53.515625 -1, "cylinder", 1.2, R_MK, G_MK, B_MK, A_MK )
local Vaca04 = createObject ( 3383, -576.07244873047,2593.0354003906,52.515625, 0, 0, -90 )
local Arma4 = createObject ( 356, -575.88653564453,2592.9829101563,53.515625, 90, 0, -90 )
setObjectScale ( Vaca04, 0.8 )
setElementCollisionsEnabled ( Vaca04, false )

local Vaca05_Estado = false
local Vaca05_Marker = createMarker ( -570.03570556641,2611.0493164063,53.515625 -1, "cylinder", 1.2, R_MK, G_MK, B_MK, A_MK )
local Vaca05 = createObject ( 3383, -571.07244873047,2611.0354003906,52.515625, 0, 0, -90 )
local Arma5 = createObject ( 356, -570.88653564453,2610.9829101563,53.515625, 90, 0, -90 )
setObjectScale ( Vaca05, 0.8 )
setElementCollisionsEnabled ( Vaca05, false )

local Vaca06_Estado = false
local Vaca06_Marker = createMarker ( -570.03570556641,2605.0493164063,53.515625 -1, "cylinder", 1.2, R_MK, G_MK, B_MK, A_MK )
local Vaca06 = createObject ( 3383, -571.07244873047,2605.0493164063,52.515625, 0, 0, -90 )
local Arma6 = createObject ( 356, -570.88653564453,2604.9829101563,53.515625, 90, 0, -90 )
setObjectScale ( Vaca06, 0.8 )
setElementCollisionsEnabled ( Vaca06, false )

local Vaca07_Estado = false
local Vaca07_Marker = createMarker ( -570.03570556641,2599.0493164063,53.515625 -1, "cylinder", 1.2, R_MK, G_MK, B_MK, A_MK )
local Vaca07 = createObject ( 3383, -571.07244873047,2599.0493164063,52.515625, 0, 0, -90 )
local Arma7 = createObject ( 356, -570.88653564453,2598.9829101563,53.515625, 90, 0, -90 )
setObjectScale ( Vaca07, 0.8 )
setElementCollisionsEnabled ( Vaca07, false )

local Vaca08_Estado = false
local Vaca08_Marker = createMarker ( -570.03570556641,2593.0493164063,53.515625 -1, "cylinder", 1.2, R_MK, G_MK, B_MK, A_MK )
local Vaca08 = createObject ( 3383, -571.07244873047,2593.0493164063,52.515625, 0, 0, -90 )
local Arma8 = createObject ( 356, -570.88653564453,2592.9829101563,53.515625, 90, 0, -90 )
setObjectScale ( Vaca08, 0.8 )
setElementCollisionsEnabled ( Vaca08, false )

--------------- // --------------- --------------- // --------------- --------------- // ---------------

function Mensagem_Peketo ( Jogador, Texto, Tipo )
    exports.Hype_MensagemDX:outputDx ( Jogador, Texto, Tipo )
end

Temporizador_Peketo = {}

function Entrar_Peketo ( marker, md )
    if md then
	    if marker == Vaca01_Marker then
		    if Vaca01_Estado == false then
		        if getElementData ( source, "Emprego" ) == "Fabricador De Armas" then
			        if not isPedInVehicle ( source ) then
		                bindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca01_Peketo )
			            exports.Hype_MsgsMarker:create ( source, "Aperte '"..LetraParaMarkers.."' Para Fabricar Armas ID 1")
				    end
			    end
			end
		elseif marker == Vaca02_Marker then
		    if Vaca02_Estado == false then
		        if getElementData ( source, "Emprego" ) == "Fabricador De Armas" then
			        if not isPedInVehicle ( source ) then
		                bindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca02_Peketo )
			            exports.Hype_MsgsMarker:create ( source, "Aperte '"..LetraParaMarkers.."' Para Fabricar Armas ID 2")
				    end
			    end
			end
		elseif marker == Vaca03_Marker then
		    if Vaca03_Estado == false then
		        if getElementData ( source, "Emprego" ) == "Fabricador De Armas" then
			        if not isPedInVehicle ( source ) then
		                bindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca03_Peketo )
			            exports.Hype_MsgsMarker:create ( source, "Aperte '"..LetraParaMarkers.."' Para Fabricar Armas ID 3")
				    end
			    end
			end
		elseif marker == Vaca04_Marker then
		    if Vaca04_Estado == false then
		        if getElementData ( source, "Emprego" ) == "Fabricador De Armas" then
			        if not isPedInVehicle ( source ) then
		                bindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca04_Peketo )
			            exports.Hype_MsgsMarker:create ( source, "Aperte '"..LetraParaMarkers.."' Para Fabricar Armas ID 4")
				    end
			    end
			end
		elseif marker == Vaca05_Marker then
		    if Vaca05_Estado == false then
		        if getElementData ( source, "Emprego" ) == "Fabricador De Armas" then
			        if not isPedInVehicle ( source ) then
		                bindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca05_Peketo )
			            exports.Hype_MsgsMarker:create ( source, "Aperte '"..LetraParaMarkers.."' Para Fabricar Armas ID 5")
				    end
			    end
			end
		elseif marker == Vaca06_Marker then
		    if Vaca05_Estado == false then
		        if getElementData ( source, "Emprego" ) == "Fabricador De Armas" then
			        if not isPedInVehicle ( source ) then
		                bindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca06_Peketo )
			            exports.Hype_MsgsMarker:create ( source, "Aperte '"..LetraParaMarkers.."' Para Fabricar Armas ID 6")
				    end
			    end
			end
		elseif marker == Vaca07_Marker then
		    if Vaca05_Estado == false then
		        if getElementData ( source, "Emprego" ) == "Fabricador De Armas" then
			        if not isPedInVehicle ( source ) then
		                bindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca07_Peketo )
			            exports.Hype_MsgsMarker:create ( source, "Aperte '"..LetraParaMarkers.."' Para Fabricar Armas ID 7")
				    end
			    end
			end
		elseif marker == Vaca08_Marker then
		    if Vaca06_Estado == false then
		        if getElementData ( source, "Emprego" ) == "Fabricador De Armas" then
			        if not isPedInVehicle ( source ) then
		                bindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca08_Peketo )
			            exports.Hype_MsgsMarker:create ( source, "Aperte '"..LetraParaMarkers.."' Para Fabricar Armas ID 8")
				    end
			    end
			end
		end
	end
end
addEventHandler ( "onPlayerMarkerHit", getRootElement ( ), Entrar_Peketo )

function Sair_Peketo ( marker, md )
    if md then
	    if marker == Vaca01_Marker then
            unbindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca01_Peketo )
            exports.Hype_MsgsMarker:delete ( source )
		elseif marker == Vaca02_Marker then
            unbindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca02_Peketo )
            exports.Hype_MsgsMarker:delete ( source )
		elseif marker == Vaca03_Marker then
            unbindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca03_Peketo )
            exports.Hype_MsgsMarker:delete ( source )
		elseif marker == Vaca04_Marker then
            unbindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca04_Peketo )
            exports.Hype_MsgsMarker:delete ( source )
		elseif marker == Vaca05_Marker then
            unbindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca05_Peketo )
            exports.Hype_MsgsMarker:delete ( source )
		elseif marker == Vaca06_Marker then
            unbindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca06_Peketo )
            exports.Hype_MsgsMarker:delete ( source )
		elseif marker == Vaca07_Marker then
            unbindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca07_Peketo )
            exports.Hype_MsgsMarker:delete ( source )
		elseif marker == Vaca08_Marker then
            unbindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca08_Peketo )
            exports.Hype_MsgsMarker:delete ( source )
		end
	end
end
addEventHandler ( "onPlayerMarkerLeave", getRootElement ( ), Sair_Peketo )

function Coletar_Arma_Vaca01_Peketo ( source )
    unbindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca01_Peketo )
    exports.Hype_MsgsMarker:delete ( source )
    if Vaca01_Estado == true or isPedInVehicle ( source ) then return end
    local Arma_Total = getElementData ( source, "Peketo_ArmaColetado" ) or 0
	if Arma_Total < 80 then
	    local Novo_Nome = getPlayerName ( source ):gsub("#%x%x%x%x%x%x","")
	    triggerClientEvent ( root, "Peketo_VacaID_Nick", root, 1, ""..Novo_Nome.."" )
		setElementFrozen ( source, true )
		setElementPosition ( source, -575.03570556641,2611.0493164063,53.515625 )
		setElementRotation ( source, 0, 0, 125 )
		Mensagem_Peketo ( source, "Aguarde: Você está Fabricando Armas!", "info" )
		setPedAnimation ( source, "bd_fire", "wash_up" )
		setElementData ( source, "Peketo_Contagem_Arma", 0 )
		setElementData ( source, "Peketo_Contagem_Arma_Estado", "Iniciado" )
	    Vaca01_Estado = true
		setTimer ( function ( )
		    setPedAnimation ( source )
		    setElementFrozen ( source, false )
			if Arma_Total == 37 then
			    Aleatorio_Litros = 43
			elseif Arma_Total == 38 then
			    Aleatorio_Litros = 42
			elseif Arma_Total == 39 then
			    Aleatorio_Litros = 41
			elseif Arma_Total == 40 then
			    Aleatorio_Litros = 40
			elseif Arma_Total == 41 then
			    Aleatorio_Litros = 39
			elseif Arma_Total == 42 then
			    Aleatorio_Litros = 38
			elseif Arma_Total == 43 then
			    Aleatorio_Litros = 37
			elseif Arma_Total == 44 then
			    Aleatorio_Litros = 36
			elseif Arma_Total == 45 then
			    Aleatorio_Litros = 35
			elseif Arma_Total == 46 then
			    Aleatorio_Litros = 34
			elseif Arma_Total == 47 then
			    Aleatorio_Litros = 33
			elseif Arma_Total == 48 then
			    Aleatorio_Litros = 32
			elseif Arma_Total == 49 then
			    Aleatorio_Litros = 31
			elseif Arma_Total == 50 then
			    Aleatorio_Litros = 30
			elseif Arma_Total == 51 then
			    Aleatorio_Litros = 29
			elseif Arma_Total == 52 then
			    Aleatorio_Litros = 28
			elseif Arma_Total == 53 then
			    Aleatorio_Litros = 27
			elseif Arma_Total == 54 then
			    Aleatorio_Litros = 26
			elseif Arma_Total == 55 then
			    Aleatorio_Litros = 25
			elseif Arma_Total == 56 then
			    Aleatorio_Litros = 24
			elseif Arma_Total == 57 then
			    Aleatorio_Litros = 23
			elseif Arma_Total == 58 then
			    Aleatorio_Litros = 22
			elseif Arma_Total == 59 then
			    Aleatorio_Litros = 21
			elseif Arma_Total == 60 then
			    Aleatorio_Litros = 20
			elseif Arma_Total == 61 then
			    Aleatorio_Litros = 17
			elseif Arma_Total == 62 then
			    Aleatorio_Litros = 18
			elseif Arma_Total == 63 then
			    Aleatorio_Litros = 17
			elseif Arma_Total == 64 then
			    Aleatorio_Litros = 16
			elseif Arma_Total == 65 then
			    Aleatorio_Litros = 15
			elseif Arma_Total == 66 then
			    Aleatorio_Litros = 14
			elseif Arma_Total == 67 then
			    Aleatorio_Litros = 12
			elseif Arma_Total == 68 then
			    Aleatorio_Litros = 12
			elseif Arma_Total == 69 then
			    Aleatorio_Litros = 11
			elseif Arma_Total == 70 then
			    Aleatorio_Litros = 10
			elseif Arma_Total == 71 then
			    Aleatorio_Litros = 9
			elseif Arma_Total == 72 then
			    Aleatorio_Litros = 8
			elseif Arma_Total == 73 then
			    Aleatorio_Litros = 7
			elseif Arma_Total == 74 then
			    Aleatorio_Litros = 6
			elseif Arma_Total == 75 then
			    Aleatorio_Litros = 5
			elseif Arma_Total == 76 then
			    Aleatorio_Litros = 4
			elseif Arma_Total == 77 then
			    Aleatorio_Litros = 3
			elseif Arma_Total == 78 then
			    Aleatorio_Litros = 2
			elseif Arma_Total == 79 then
			    Aleatorio_Litros = 1
			elseif Arma_Total == 80 then
			    Aleatorio_Litros = 0
			elseif Arma_Total < 38 then
			    Aleatorio_Litros = math.random ( 5, 13 )
			end
    	    setElementData ( source, "Peketo_ArmaColetado", Arma_Total + Aleatorio_Litros )
	 	    local Arma_Total_Final = getElementData ( source, "Peketo_ArmaColetado" ) or 0
			Mensagem_Peketo ( source, "Sucesso: Você Acabou de Fabricar "..Aleatorio_Litros.." Armas, Totalizando em "..Arma_Total_Final.." Armas!", "success" )
		    triggerClientEvent ( root, "Peketo_VacaID_Nick", root, 1, "Ninguem" )
		    Vaca01_Estado = false
			setElementData ( source, "Peketo_Contagem_Arma_Estado", "Parado" )
		end, Tempo_Para_Coletar_Arma, 1 )
	else
	    local Arma_Total_Final = getElementData ( source, "Peketo_ArmaColetado" ) or 0
		Mensagem_Peketo ( source, "Erro: Você Já possui "..Arma_Total_Final.." Armas, Entre no Caminhão e de /Carregar!", "error" )
	end
end

function Coletar_Arma_Vaca02_Peketo ( source )
    unbindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca02_Peketo )
    exports.Hype_MsgsMarker:delete ( source )
    if Vaca02_Estado == true or isPedInVehicle ( source ) then return end
    local Arma_Total = getElementData ( source, "Peketo_ArmaColetado" ) or 0
	if Arma_Total < 80 then
	    local Novo_Nome = getPlayerName ( source ):gsub("#%x%x%x%x%x%x","")
	    triggerClientEvent ( root, "Peketo_VacaID_Nick", root, 2, ""..Novo_Nome.."" )
		setElementFrozen ( source, true )
		setElementPosition ( source, -575.03570556641,2605.0493164063,53.515625 )
		setElementRotation ( source, 0, 0, 125 )
		Mensagem_Peketo ( source, "Aguarde: Você está Fabricando Armas!", "info" )
		setPedAnimation ( source, "bd_fire", "wash_up" )
		setElementData ( source, "Peketo_Contagem_Arma", 0 )
		setElementData ( source, "Peketo_Contagem_Arma_Estado", "Iniciado" )
	    Vaca02_Estado = true
		setTimer ( function ( )
		    setPedAnimation ( source )
		    setElementFrozen ( source, false )
			if Arma_Total == 37 then
			    Aleatorio_Litros = 43
			elseif Arma_Total == 38 then
			    Aleatorio_Litros = 42
			elseif Arma_Total == 39 then
			    Aleatorio_Litros = 41
			elseif Arma_Total == 40 then
			    Aleatorio_Litros = 40
			elseif Arma_Total == 41 then
			    Aleatorio_Litros = 39
			elseif Arma_Total == 42 then
			    Aleatorio_Litros = 38
			elseif Arma_Total == 43 then
			    Aleatorio_Litros = 37
			elseif Arma_Total == 44 then
			    Aleatorio_Litros = 36
			elseif Arma_Total == 45 then
			    Aleatorio_Litros = 35
			elseif Arma_Total == 46 then
			    Aleatorio_Litros = 34
			elseif Arma_Total == 47 then
			    Aleatorio_Litros = 33
			elseif Arma_Total == 48 then
			    Aleatorio_Litros = 32
			elseif Arma_Total == 49 then
			    Aleatorio_Litros = 31
			elseif Arma_Total == 50 then
			    Aleatorio_Litros = 30
			elseif Arma_Total == 51 then
			    Aleatorio_Litros = 29
			elseif Arma_Total == 52 then
			    Aleatorio_Litros = 28
			elseif Arma_Total == 53 then
			    Aleatorio_Litros = 27
			elseif Arma_Total == 54 then
			    Aleatorio_Litros = 26
			elseif Arma_Total == 55 then
			    Aleatorio_Litros = 25
			elseif Arma_Total == 56 then
			    Aleatorio_Litros = 24
			elseif Arma_Total == 57 then
			    Aleatorio_Litros = 23
			elseif Arma_Total == 58 then
			    Aleatorio_Litros = 22
			elseif Arma_Total == 59 then
			    Aleatorio_Litros = 21
			elseif Arma_Total == 60 then
			    Aleatorio_Litros = 20
			elseif Arma_Total == 61 then
			    Aleatorio_Litros = 17
			elseif Arma_Total == 62 then
			    Aleatorio_Litros = 18
			elseif Arma_Total == 63 then
			    Aleatorio_Litros = 17
			elseif Arma_Total == 64 then
			    Aleatorio_Litros = 16
			elseif Arma_Total == 65 then
			    Aleatorio_Litros = 15
			elseif Arma_Total == 66 then
			    Aleatorio_Litros = 14
			elseif Arma_Total == 67 then
			    Aleatorio_Litros = 12
			elseif Arma_Total == 68 then
			    Aleatorio_Litros = 12
			elseif Arma_Total == 69 then
			    Aleatorio_Litros = 11
			elseif Arma_Total == 70 then
			    Aleatorio_Litros = 10
			elseif Arma_Total == 71 then
			    Aleatorio_Litros = 9
			elseif Arma_Total == 72 then
			    Aleatorio_Litros = 8
			elseif Arma_Total == 73 then
			    Aleatorio_Litros = 7
			elseif Arma_Total == 74 then
			    Aleatorio_Litros = 6
			elseif Arma_Total == 75 then
			    Aleatorio_Litros = 5
			elseif Arma_Total == 76 then
			    Aleatorio_Litros = 4
			elseif Arma_Total == 77 then
			    Aleatorio_Litros = 3
			elseif Arma_Total == 78 then
			    Aleatorio_Litros = 2
			elseif Arma_Total == 79 then
			    Aleatorio_Litros = 1
			elseif Arma_Total == 80 then
			    Aleatorio_Litros = 0
			elseif Arma_Total < 38 then
			    Aleatorio_Litros = math.random ( 5, 13 )
			end
    	    setElementData ( source, "Peketo_ArmaColetado", Arma_Total + Aleatorio_Litros )
	 	    local Arma_Total_Final = getElementData ( source, "Peketo_ArmaColetado" ) or 0
			Mensagem_Peketo ( source, "Sucesso: Você Acabou de Fabricar "..Aleatorio_Litros.." Armas, Totalizando em "..Arma_Total_Final.." Armas!", "success" )
		    triggerClientEvent ( root, "Peketo_VacaID_Nick", root, 2, "Ninguem" )
		    Vaca02_Estado = false
			setElementData ( source, "Peketo_Contagem_Arma_Estado", "Parado" )
		end, Tempo_Para_Coletar_Arma, 1 )
	else
	    local Arma_Total_Final = getElementData ( source, "Peketo_ArmaColetado" ) or 0
		Mensagem_Peketo ( source, "Erro: Você Já possui "..Arma_Total_Final.." Armas, Entre no Caminhão e de /Carregar!", "error" )
	end
end

function Coletar_Arma_Vaca03_Peketo ( source )
    unbindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca03_Peketo )
    exports.Hype_MsgsMarker:delete ( source )
    if Vaca03_Estado == true or isPedInVehicle ( source ) then return end
    local Arma_Total = getElementData ( source, "Peketo_ArmaColetado" ) or 0
	if Arma_Total < 80 then
	    local Novo_Nome = getPlayerName ( source ):gsub("#%x%x%x%x%x%x","")
	    triggerClientEvent ( root, "Peketo_VacaID_Nick", root, 3, ""..Novo_Nome.."" )
		setElementFrozen ( source, true )
		setElementPosition ( source, -575.03570556641,2599.0493164063,53.515625 )
		setElementRotation ( source, 0, 0, 125 )
		Mensagem_Peketo ( source, "Aguarde: Você está Fabricando Armas!", "info" )
		setPedAnimation ( source, "bd_fire", "wash_up" )
		setElementData ( source, "Peketo_Contagem_Arma", 0 )
		setElementData ( source, "Peketo_Contagem_Arma_Estado", "Iniciado" )
	    Vaca03_Estado = true
		setTimer ( function ( )
		    setPedAnimation ( source )
		    setElementFrozen ( source, false )
			if Arma_Total == 37 then
			    Aleatorio_Litros = 43
			elseif Arma_Total == 38 then
			    Aleatorio_Litros = 42
			elseif Arma_Total == 39 then
			    Aleatorio_Litros = 41
			elseif Arma_Total == 40 then
			    Aleatorio_Litros = 40
			elseif Arma_Total == 41 then
			    Aleatorio_Litros = 39
			elseif Arma_Total == 42 then
			    Aleatorio_Litros = 38
			elseif Arma_Total == 43 then
			    Aleatorio_Litros = 37
			elseif Arma_Total == 44 then
			    Aleatorio_Litros = 36
			elseif Arma_Total == 45 then
			    Aleatorio_Litros = 35
			elseif Arma_Total == 46 then
			    Aleatorio_Litros = 34
			elseif Arma_Total == 47 then
			    Aleatorio_Litros = 33
			elseif Arma_Total == 48 then
			    Aleatorio_Litros = 32
			elseif Arma_Total == 49 then
			    Aleatorio_Litros = 31
			elseif Arma_Total == 50 then
			    Aleatorio_Litros = 30
			elseif Arma_Total == 51 then
			    Aleatorio_Litros = 29
			elseif Arma_Total == 52 then
			    Aleatorio_Litros = 28
			elseif Arma_Total == 53 then
			    Aleatorio_Litros = 27
			elseif Arma_Total == 54 then
			    Aleatorio_Litros = 26
			elseif Arma_Total == 55 then
			    Aleatorio_Litros = 25
			elseif Arma_Total == 56 then
			    Aleatorio_Litros = 24
			elseif Arma_Total == 57 then
			    Aleatorio_Litros = 23
			elseif Arma_Total == 58 then
			    Aleatorio_Litros = 22
			elseif Arma_Total == 59 then
			    Aleatorio_Litros = 21
			elseif Arma_Total == 60 then
			    Aleatorio_Litros = 20
			elseif Arma_Total == 61 then
			    Aleatorio_Litros = 17
			elseif Arma_Total == 62 then
			    Aleatorio_Litros = 18
			elseif Arma_Total == 63 then
			    Aleatorio_Litros = 17
			elseif Arma_Total == 64 then
			    Aleatorio_Litros = 16
			elseif Arma_Total == 65 then
			    Aleatorio_Litros = 15
			elseif Arma_Total == 66 then
			    Aleatorio_Litros = 14
			elseif Arma_Total == 67 then
			    Aleatorio_Litros = 12
			elseif Arma_Total == 68 then
			    Aleatorio_Litros = 12
			elseif Arma_Total == 69 then
			    Aleatorio_Litros = 11
			elseif Arma_Total == 70 then
			    Aleatorio_Litros = 10
			elseif Arma_Total == 71 then
			    Aleatorio_Litros = 9
			elseif Arma_Total == 72 then
			    Aleatorio_Litros = 8
			elseif Arma_Total == 73 then
			    Aleatorio_Litros = 7
			elseif Arma_Total == 74 then
			    Aleatorio_Litros = 6
			elseif Arma_Total == 75 then
			    Aleatorio_Litros = 5
			elseif Arma_Total == 76 then
			    Aleatorio_Litros = 4
			elseif Arma_Total == 77 then
			    Aleatorio_Litros = 3
			elseif Arma_Total == 78 then
			    Aleatorio_Litros = 2
			elseif Arma_Total == 79 then
			    Aleatorio_Litros = 1
			elseif Arma_Total == 80 then
			    Aleatorio_Litros = 0
			elseif Arma_Total < 38 then
			    Aleatorio_Litros = math.random ( 5, 13 )
			end
    	    setElementData ( source, "Peketo_ArmaColetado", Arma_Total + Aleatorio_Litros )
	 	    local Arma_Total_Final = getElementData ( source, "Peketo_ArmaColetado" ) or 0
			Mensagem_Peketo ( source, "Sucesso: Você Acabou de Fabricar "..Aleatorio_Litros.." Armas, Totalizando em "..Arma_Total_Final.." Armas!", "success" )
		    triggerClientEvent ( root, "Peketo_VacaID_Nick", root, 3, "Ninguem" )
		    Vaca03_Estado = false
			setElementData ( source, "Peketo_Contagem_Arma_Estado", "Parado" )
		end, Tempo_Para_Coletar_Arma, 1 )
	else
	    local Arma_Total_Final = getElementData ( source, "Peketo_ArmaColetado" ) or 0
		Mensagem_Peketo ( source, "Erro: Você Já possui "..Arma_Total_Final.." Armas, Entre no Caminhão e de /Carregar!", "error" )
	end
end

function Coletar_Arma_Vaca04_Peketo ( source )
    unbindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca04_Peketo )
    exports.Hype_MsgsMarker:delete ( source )
    if Vaca04_Estado == true or isPedInVehicle ( source ) then return end
    local Arma_Total = getElementData ( source, "Peketo_ArmaColetado" ) or 0
	if Arma_Total < 80 then
	    local Novo_Nome = getPlayerName ( source ):gsub("#%x%x%x%x%x%x","")
	    triggerClientEvent ( root, "Peketo_VacaID_Nick", root, 4, ""..Novo_Nome.."" )
		setElementFrozen ( source, true )
		setElementPosition ( source, -575.03570556641,2593.0493164063,53.515625 )
		setElementRotation ( source, 0, 0, 125 )
		Mensagem_Peketo ( source, "Aguarde: Você está Fabricando Armas!", "info" )
		setPedAnimation ( source, "bd_fire", "wash_up" )
		setElementData ( source, "Peketo_Contagem_Arma", 0 )
		setElementData ( source, "Peketo_Contagem_Arma_Estado", "Iniciado" )
	    Vaca04_Estado = true
		setTimer ( function ( )
		    setPedAnimation ( source )
		    setElementFrozen ( source, false )
			if Arma_Total == 37 then
			    Aleatorio_Litros = 43
			elseif Arma_Total == 38 then
			    Aleatorio_Litros = 42
			elseif Arma_Total == 39 then
			    Aleatorio_Litros = 41
			elseif Arma_Total == 40 then
			    Aleatorio_Litros = 40
			elseif Arma_Total == 41 then
			    Aleatorio_Litros = 39
			elseif Arma_Total == 42 then
			    Aleatorio_Litros = 38
			elseif Arma_Total == 43 then
			    Aleatorio_Litros = 37
			elseif Arma_Total == 44 then
			    Aleatorio_Litros = 36
			elseif Arma_Total == 45 then
			    Aleatorio_Litros = 35
			elseif Arma_Total == 46 then
			    Aleatorio_Litros = 34
			elseif Arma_Total == 47 then
			    Aleatorio_Litros = 33
			elseif Arma_Total == 48 then
			    Aleatorio_Litros = 32
			elseif Arma_Total == 49 then
			    Aleatorio_Litros = 31
			elseif Arma_Total == 50 then
			    Aleatorio_Litros = 30
			elseif Arma_Total == 51 then
			    Aleatorio_Litros = 29
			elseif Arma_Total == 52 then
			    Aleatorio_Litros = 28
			elseif Arma_Total == 53 then
			    Aleatorio_Litros = 27
			elseif Arma_Total == 54 then
			    Aleatorio_Litros = 26
			elseif Arma_Total == 55 then
			    Aleatorio_Litros = 25
			elseif Arma_Total == 56 then
			    Aleatorio_Litros = 24
			elseif Arma_Total == 57 then
			    Aleatorio_Litros = 23
			elseif Arma_Total == 58 then
			    Aleatorio_Litros = 22
			elseif Arma_Total == 59 then
			    Aleatorio_Litros = 21
			elseif Arma_Total == 60 then
			    Aleatorio_Litros = 20
			elseif Arma_Total == 61 then
			    Aleatorio_Litros = 17
			elseif Arma_Total == 62 then
			    Aleatorio_Litros = 18
			elseif Arma_Total == 63 then
			    Aleatorio_Litros = 17
			elseif Arma_Total == 64 then
			    Aleatorio_Litros = 16
			elseif Arma_Total == 65 then
			    Aleatorio_Litros = 15
			elseif Arma_Total == 66 then
			    Aleatorio_Litros = 14
			elseif Arma_Total == 67 then
			    Aleatorio_Litros = 12
			elseif Arma_Total == 68 then
			    Aleatorio_Litros = 12
			elseif Arma_Total == 69 then
			    Aleatorio_Litros = 11
			elseif Arma_Total == 70 then
			    Aleatorio_Litros = 10
			elseif Arma_Total == 71 then
			    Aleatorio_Litros = 9
			elseif Arma_Total == 72 then
			    Aleatorio_Litros = 8
			elseif Arma_Total == 73 then
			    Aleatorio_Litros = 7
			elseif Arma_Total == 74 then
			    Aleatorio_Litros = 6
			elseif Arma_Total == 75 then
			    Aleatorio_Litros = 5
			elseif Arma_Total == 76 then
			    Aleatorio_Litros = 4
			elseif Arma_Total == 77 then
			    Aleatorio_Litros = 3
			elseif Arma_Total == 78 then
			    Aleatorio_Litros = 2
			elseif Arma_Total == 79 then
			    Aleatorio_Litros = 1
			elseif Arma_Total == 80 then
			    Aleatorio_Litros = 0
			elseif Arma_Total < 38 then
			    Aleatorio_Litros = math.random ( 5, 13 )
			end
    	    setElementData ( source, "Peketo_ArmaColetado", Arma_Total + Aleatorio_Litros )
	 	    local Arma_Total_Final = getElementData ( source, "Peketo_ArmaColetado" ) or 0
			Mensagem_Peketo ( source, "Sucesso: Você Acabou de Fabricar "..Aleatorio_Litros.." Armas, Totalizando em "..Arma_Total_Final.." Armas!", "success" )
		    triggerClientEvent ( root, "Peketo_VacaID_Nick", root, 4, "Ninguem" )
		    Vaca04_Estado = false
			setElementData ( source, "Peketo_Contagem_Arma_Estado", "Parado" )
		end, Tempo_Para_Coletar_Arma, 1 )
	else
	    local Arma_Total_Final = getElementData ( source, "Peketo_ArmaColetado" ) or 0
		Mensagem_Peketo ( source, "Erro: Você Já possui "..Arma_Total_Final.." Armas, Entre no Caminhão e de /Carregar!", "error" )
	end
end

function Coletar_Arma_Vaca05_Peketo ( source )
    unbindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca05_Peketo )
    exports.Hype_MsgsMarker:delete ( source )
    if Vaca05_Estado == true or isPedInVehicle ( source ) then return end
    local Arma_Total = getElementData ( source, "Peketo_ArmaColetado" ) or 0
	if Arma_Total < 80 then
	    local Novo_Nome = getPlayerName ( source ):gsub("#%x%x%x%x%x%x","")
	    triggerClientEvent ( root, "Peketo_VacaID_Nick", root, 5, ""..Novo_Nome.."" )
		setElementFrozen ( source, true )
		setElementPosition ( source, -570.03570556641,2611.0493164063,53.515625 )
		setElementRotation ( source, 0, 0, 125 )
		Mensagem_Peketo ( source, "Aguarde: Você está Fabricando Armas!", "info" )
		setPedAnimation ( source, "bd_fire", "wash_up" )
		setElementData ( source, "Peketo_Contagem_Arma", 0 )
		setElementData ( source, "Peketo_Contagem_Arma_Estado", "Iniciado" )
	    Vaca05_Estado = true
		setTimer ( function ( )
		    setPedAnimation ( source )
		    setElementFrozen ( source, false )
			if Arma_Total == 37 then
			    Aleatorio_Litros = 43
			elseif Arma_Total == 38 then
			    Aleatorio_Litros = 42
			elseif Arma_Total == 39 then
			    Aleatorio_Litros = 41
			elseif Arma_Total == 40 then
			    Aleatorio_Litros = 40
			elseif Arma_Total == 41 then
			    Aleatorio_Litros = 39
			elseif Arma_Total == 42 then
			    Aleatorio_Litros = 38
			elseif Arma_Total == 43 then
			    Aleatorio_Litros = 37
			elseif Arma_Total == 44 then
			    Aleatorio_Litros = 36
			elseif Arma_Total == 45 then
			    Aleatorio_Litros = 35
			elseif Arma_Total == 46 then
			    Aleatorio_Litros = 34
			elseif Arma_Total == 47 then
			    Aleatorio_Litros = 33
			elseif Arma_Total == 48 then
			    Aleatorio_Litros = 32
			elseif Arma_Total == 49 then
			    Aleatorio_Litros = 31
			elseif Arma_Total == 50 then
			    Aleatorio_Litros = 30
			elseif Arma_Total == 51 then
			    Aleatorio_Litros = 29
			elseif Arma_Total == 52 then
			    Aleatorio_Litros = 28
			elseif Arma_Total == 53 then
			    Aleatorio_Litros = 27
			elseif Arma_Total == 54 then
			    Aleatorio_Litros = 26
			elseif Arma_Total == 55 then
			    Aleatorio_Litros = 25
			elseif Arma_Total == 56 then
			    Aleatorio_Litros = 24
			elseif Arma_Total == 57 then
			    Aleatorio_Litros = 23
			elseif Arma_Total == 58 then
			    Aleatorio_Litros = 22
			elseif Arma_Total == 59 then
			    Aleatorio_Litros = 21
			elseif Arma_Total == 60 then
			    Aleatorio_Litros = 20
			elseif Arma_Total == 61 then
			    Aleatorio_Litros = 17
			elseif Arma_Total == 62 then
			    Aleatorio_Litros = 18
			elseif Arma_Total == 63 then
			    Aleatorio_Litros = 17
			elseif Arma_Total == 64 then
			    Aleatorio_Litros = 16
			elseif Arma_Total == 65 then
			    Aleatorio_Litros = 15
			elseif Arma_Total == 66 then
			    Aleatorio_Litros = 14
			elseif Arma_Total == 67 then
			    Aleatorio_Litros = 12
			elseif Arma_Total == 68 then
			    Aleatorio_Litros = 12
			elseif Arma_Total == 69 then
			    Aleatorio_Litros = 11
			elseif Arma_Total == 70 then
			    Aleatorio_Litros = 10
			elseif Arma_Total == 71 then
			    Aleatorio_Litros = 9
			elseif Arma_Total == 72 then
			    Aleatorio_Litros = 8
			elseif Arma_Total == 73 then
			    Aleatorio_Litros = 7
			elseif Arma_Total == 74 then
			    Aleatorio_Litros = 6
			elseif Arma_Total == 75 then
			    Aleatorio_Litros = 5
			elseif Arma_Total == 76 then
			    Aleatorio_Litros = 4
			elseif Arma_Total == 77 then
			    Aleatorio_Litros = 3
			elseif Arma_Total == 78 then
			    Aleatorio_Litros = 2
			elseif Arma_Total == 79 then
			    Aleatorio_Litros = 1
			elseif Arma_Total == 80 then
			    Aleatorio_Litros = 0
			elseif Arma_Total < 38 then
			    Aleatorio_Litros = math.random ( 5, 13 )
			end
    	    setElementData ( source, "Peketo_ArmaColetado", Arma_Total + Aleatorio_Litros )
	 	    local Arma_Total_Final = getElementData ( source, "Peketo_ArmaColetado" ) or 0
			Mensagem_Peketo ( source, "Sucesso: Você Acabou de Fabricar "..Aleatorio_Litros.." Armas, Totalizando em "..Arma_Total_Final.." Armas!", "success" )
		    triggerClientEvent ( root, "Peketo_VacaID_Nick", root, 5, "Ninguem" )
		    Vaca05_Estado = false
			setElementData ( source, "Peketo_Contagem_Arma_Estado", "Parado" )
		end, Tempo_Para_Coletar_Arma, 1 )
	else
	    local Arma_Total_Final = getElementData ( source, "Peketo_ArmaColetado" ) or 0
		Mensagem_Peketo ( source, "Erro: Você Já possui "..Arma_Total_Final.." Armas, Entre no Caminhão e de /Carregar!", "error" )
	end
end

function Coletar_Arma_Vaca06_Peketo ( source )
    unbindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca06_Peketo )
    exports.Hype_MsgsMarker:delete ( source )
    if Vaca06_Estado == true or isPedInVehicle ( source ) then return end
    local Arma_Total = getElementData ( source, "Peketo_ArmaColetado" ) or 0
	if Arma_Total < 80 then
	    local Novo_Nome = getPlayerName ( source ):gsub("#%x%x%x%x%x%x","")
	    triggerClientEvent ( root, "Peketo_VacaID_Nick", root, 6, ""..Novo_Nome.."" )
		setElementFrozen ( source, true )
		setElementPosition ( source, -570.03570556641,2605.0493164063,53.515625 )
		setElementRotation ( source, 0, 0, 125 )
		Mensagem_Peketo ( source, "Aguarde: Você está Fabricando Armas!", "info" )
		setPedAnimation ( source, "bd_fire", "wash_up" )
		setElementData ( source, "Peketo_Contagem_Arma", 0 )
		setElementData ( source, "Peketo_Contagem_Arma_Estado", "Iniciado" )
	    Vaca06_Estado = true
		setTimer ( function ( )
		    setPedAnimation ( source )
		    setElementFrozen ( source, false )
			if Arma_Total == 37 then
			    Aleatorio_Litros = 43
			elseif Arma_Total == 38 then
			    Aleatorio_Litros = 42
			elseif Arma_Total == 39 then
			    Aleatorio_Litros = 41
			elseif Arma_Total == 40 then
			    Aleatorio_Litros = 40
			elseif Arma_Total == 41 then
			    Aleatorio_Litros = 39
			elseif Arma_Total == 42 then
			    Aleatorio_Litros = 38
			elseif Arma_Total == 43 then
			    Aleatorio_Litros = 37
			elseif Arma_Total == 44 then
			    Aleatorio_Litros = 36
			elseif Arma_Total == 45 then
			    Aleatorio_Litros = 35
			elseif Arma_Total == 46 then
			    Aleatorio_Litros = 34
			elseif Arma_Total == 47 then
			    Aleatorio_Litros = 33
			elseif Arma_Total == 48 then
			    Aleatorio_Litros = 32
			elseif Arma_Total == 49 then
			    Aleatorio_Litros = 31
			elseif Arma_Total == 50 then
			    Aleatorio_Litros = 30
			elseif Arma_Total == 51 then
			    Aleatorio_Litros = 29
			elseif Arma_Total == 52 then
			    Aleatorio_Litros = 28
			elseif Arma_Total == 53 then
			    Aleatorio_Litros = 27
			elseif Arma_Total == 54 then
			    Aleatorio_Litros = 26
			elseif Arma_Total == 55 then
			    Aleatorio_Litros = 25
			elseif Arma_Total == 56 then
			    Aleatorio_Litros = 24
			elseif Arma_Total == 57 then
			    Aleatorio_Litros = 23
			elseif Arma_Total == 58 then
			    Aleatorio_Litros = 22
			elseif Arma_Total == 59 then
			    Aleatorio_Litros = 21
			elseif Arma_Total == 60 then
			    Aleatorio_Litros = 20
			elseif Arma_Total == 61 then
			    Aleatorio_Litros = 17
			elseif Arma_Total == 62 then
			    Aleatorio_Litros = 18
			elseif Arma_Total == 63 then
			    Aleatorio_Litros = 17
			elseif Arma_Total == 64 then
			    Aleatorio_Litros = 16
			elseif Arma_Total == 65 then
			    Aleatorio_Litros = 15
			elseif Arma_Total == 66 then
			    Aleatorio_Litros = 14
			elseif Arma_Total == 67 then
			    Aleatorio_Litros = 12
			elseif Arma_Total == 68 then
			    Aleatorio_Litros = 12
			elseif Arma_Total == 69 then
			    Aleatorio_Litros = 11
			elseif Arma_Total == 70 then
			    Aleatorio_Litros = 10
			elseif Arma_Total == 71 then
			    Aleatorio_Litros = 9
			elseif Arma_Total == 72 then
			    Aleatorio_Litros = 8
			elseif Arma_Total == 73 then
			    Aleatorio_Litros = 7
			elseif Arma_Total == 74 then
			    Aleatorio_Litros = 6
			elseif Arma_Total == 75 then
			    Aleatorio_Litros = 5
			elseif Arma_Total == 76 then
			    Aleatorio_Litros = 4
			elseif Arma_Total == 77 then
			    Aleatorio_Litros = 3
			elseif Arma_Total == 78 then
			    Aleatorio_Litros = 2
			elseif Arma_Total == 79 then
			    Aleatorio_Litros = 1
			elseif Arma_Total == 80 then
			    Aleatorio_Litros = 0
			elseif Arma_Total < 38 then
			    Aleatorio_Litros = math.random ( 5, 13 )
			end
    	    setElementData ( source, "Peketo_ArmaColetado", Arma_Total + Aleatorio_Litros )
	 	    local Arma_Total_Final = getElementData ( source, "Peketo_ArmaColetado" ) or 0
			Mensagem_Peketo ( source, "Sucesso: Você Acabou de Fabricar "..Aleatorio_Litros.." Armas, Totalizando em "..Arma_Total_Final.." Armas!", "success" )
		    triggerClientEvent ( root, "Peketo_VacaID_Nick", root, 6, "Ninguem" )
		    Vaca06_Estado = false
			setElementData ( source, "Peketo_Contagem_Arma_Estado", "Parado" )
		end, Tempo_Para_Coletar_Arma, 1 )
	else
	    local Arma_Total_Final = getElementData ( source, "Peketo_ArmaColetado" ) or 0
		Mensagem_Peketo ( source, "Erro: Você Já possui "..Arma_Total_Final.." Armas, Entre no Caminhão e de /Carregar!", "error" )
	end
end

function Coletar_Arma_Vaca07_Peketo ( source )
    unbindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca07_Peketo )
    exports.Hype_MsgsMarker:delete ( source )
    if Vaca07_Estado == true or isPedInVehicle ( source ) then return end
    local Arma_Total = getElementData ( source, "Peketo_ArmaColetado" ) or 0
	if Arma_Total < 80 then
	    local Novo_Nome = getPlayerName ( source ):gsub("#%x%x%x%x%x%x","")
	    triggerClientEvent ( root, "Peketo_VacaID_Nick", root, 7, ""..Novo_Nome.."" )
		setElementFrozen ( source, true )
		setElementPosition ( source, -570.03570556641,2599.0493164063,53.515625 )
		setElementRotation ( source, 0, 0, 125 )
		Mensagem_Peketo ( source, "Aguarde: Você está Fabricando Armas!", "info" )
		setPedAnimation ( source, "bd_fire", "wash_up" )
		setElementData ( source, "Peketo_Contagem_Arma", 0 )
		setElementData ( source, "Peketo_Contagem_Arma_Estado", "Iniciado" )
	    Vaca07_Estado = true
		setTimer ( function ( )
		    setPedAnimation ( source )
		    setElementFrozen ( source, false )
			if Arma_Total == 37 then
			    Aleatorio_Litros = 43
			elseif Arma_Total == 38 then
			    Aleatorio_Litros = 42
			elseif Arma_Total == 39 then
			    Aleatorio_Litros = 41
			elseif Arma_Total == 40 then
			    Aleatorio_Litros = 40
			elseif Arma_Total == 41 then
			    Aleatorio_Litros = 39
			elseif Arma_Total == 42 then
			    Aleatorio_Litros = 38
			elseif Arma_Total == 43 then
			    Aleatorio_Litros = 37
			elseif Arma_Total == 44 then
			    Aleatorio_Litros = 36
			elseif Arma_Total == 45 then
			    Aleatorio_Litros = 35
			elseif Arma_Total == 46 then
			    Aleatorio_Litros = 34
			elseif Arma_Total == 47 then
			    Aleatorio_Litros = 33
			elseif Arma_Total == 48 then
			    Aleatorio_Litros = 32
			elseif Arma_Total == 49 then
			    Aleatorio_Litros = 31
			elseif Arma_Total == 50 then
			    Aleatorio_Litros = 30
			elseif Arma_Total == 51 then
			    Aleatorio_Litros = 29
			elseif Arma_Total == 52 then
			    Aleatorio_Litros = 28
			elseif Arma_Total == 53 then
			    Aleatorio_Litros = 27
			elseif Arma_Total == 54 then
			    Aleatorio_Litros = 26
			elseif Arma_Total == 55 then
			    Aleatorio_Litros = 25
			elseif Arma_Total == 56 then
			    Aleatorio_Litros = 24
			elseif Arma_Total == 57 then
			    Aleatorio_Litros = 23
			elseif Arma_Total == 58 then
			    Aleatorio_Litros = 22
			elseif Arma_Total == 59 then
			    Aleatorio_Litros = 21
			elseif Arma_Total == 60 then
			    Aleatorio_Litros = 20
			elseif Arma_Total == 61 then
			    Aleatorio_Litros = 17
			elseif Arma_Total == 62 then
			    Aleatorio_Litros = 18
			elseif Arma_Total == 63 then
			    Aleatorio_Litros = 17
			elseif Arma_Total == 64 then
			    Aleatorio_Litros = 16
			elseif Arma_Total == 65 then
			    Aleatorio_Litros = 15
			elseif Arma_Total == 66 then
			    Aleatorio_Litros = 14
			elseif Arma_Total == 67 then
			    Aleatorio_Litros = 12
			elseif Arma_Total == 68 then
			    Aleatorio_Litros = 12
			elseif Arma_Total == 69 then
			    Aleatorio_Litros = 11
			elseif Arma_Total == 70 then
			    Aleatorio_Litros = 10
			elseif Arma_Total == 71 then
			    Aleatorio_Litros = 9
			elseif Arma_Total == 72 then
			    Aleatorio_Litros = 8
			elseif Arma_Total == 73 then
			    Aleatorio_Litros = 7
			elseif Arma_Total == 74 then
			    Aleatorio_Litros = 6
			elseif Arma_Total == 75 then
			    Aleatorio_Litros = 5
			elseif Arma_Total == 76 then
			    Aleatorio_Litros = 4
			elseif Arma_Total == 77 then
			    Aleatorio_Litros = 3
			elseif Arma_Total == 78 then
			    Aleatorio_Litros = 2
			elseif Arma_Total == 79 then
			    Aleatorio_Litros = 1
			elseif Arma_Total == 80 then
			    Aleatorio_Litros = 0
			elseif Arma_Total < 38 then
			    Aleatorio_Litros = math.random ( 5, 13 )
			end
    	    setElementData ( source, "Peketo_ArmaColetado", Arma_Total + Aleatorio_Litros )
	 	    local Arma_Total_Final = getElementData ( source, "Peketo_ArmaColetado" ) or 0
			Mensagem_Peketo ( source, "Sucesso: Você Acabou de Fabricar "..Aleatorio_Litros.." Armas, Totalizando em "..Arma_Total_Final.." Armas!", "success" )
		    triggerClientEvent ( root, "Peketo_VacaID_Nick", root, 7, "Ninguem" )
		    Vaca07_Estado = false
			setElementData ( source, "Peketo_Contagem_Arma_Estado", "Parado" )
		end, Tempo_Para_Coletar_Arma, 1 )
	else
	    local Arma_Total_Final = getElementData ( source, "Peketo_ArmaColetado" ) or 0
		Mensagem_Peketo ( source, "Erro: Você Já possui "..Arma_Total_Final.." Armas, Entre no Caminhão e de /Carregar!", "error" )
	end
end

function Coletar_Arma_Vaca08_Peketo ( source )
    unbindKey ( source, LetraParaMarkers, "down", Coletar_Arma_Vaca08_Peketo )
    exports.Hype_MsgsMarker:delete ( source )
    if Vaca08_Estado == true or isPedInVehicle ( source ) then return end
    local Arma_Total = getElementData ( source, "Peketo_ArmaColetado" ) or 0
	if Arma_Total < 80 then
	    local Novo_Nome = getPlayerName ( source ):gsub("#%x%x%x%x%x%x","")
	    triggerClientEvent ( root, "Peketo_VacaID_Nick", root, 8, ""..Novo_Nome.."" )
		setElementFrozen ( source, true )
		setElementPosition ( source, -570.03570556641,2593.0493164063,53.515625 )
		setElementRotation ( source, 0, 0, 125 )
		Mensagem_Peketo ( source, "Aguarde: Você está Fabricando Armas!", "info" )
		setPedAnimation ( source, "bd_fire", "wash_up" )
		setElementData ( source, "Peketo_Contagem_Arma", 0 )
		setElementData ( source, "Peketo_Contagem_Arma_Estado", "Iniciado" )
	    Vaca08_Estado = true
		setTimer ( function ( )
		    setPedAnimation ( source )
		    setElementFrozen ( source, false )
			if Arma_Total == 37 then
			    Aleatorio_Litros = 43
			elseif Arma_Total == 38 then
			    Aleatorio_Litros = 42
			elseif Arma_Total == 39 then
			    Aleatorio_Litros = 41
			elseif Arma_Total == 40 then
			    Aleatorio_Litros = 40
			elseif Arma_Total == 41 then
			    Aleatorio_Litros = 39
			elseif Arma_Total == 42 then
			    Aleatorio_Litros = 38
			elseif Arma_Total == 43 then
			    Aleatorio_Litros = 37
			elseif Arma_Total == 44 then
			    Aleatorio_Litros = 36
			elseif Arma_Total == 45 then
			    Aleatorio_Litros = 35
			elseif Arma_Total == 46 then
			    Aleatorio_Litros = 34
			elseif Arma_Total == 47 then
			    Aleatorio_Litros = 33
			elseif Arma_Total == 48 then
			    Aleatorio_Litros = 32
			elseif Arma_Total == 49 then
			    Aleatorio_Litros = 31
			elseif Arma_Total == 50 then
			    Aleatorio_Litros = 30
			elseif Arma_Total == 51 then
			    Aleatorio_Litros = 29
			elseif Arma_Total == 52 then
			    Aleatorio_Litros = 28
			elseif Arma_Total == 53 then
			    Aleatorio_Litros = 27
			elseif Arma_Total == 54 then
			    Aleatorio_Litros = 26
			elseif Arma_Total == 55 then
			    Aleatorio_Litros = 25
			elseif Arma_Total == 56 then
			    Aleatorio_Litros = 24
			elseif Arma_Total == 57 then
			    Aleatorio_Litros = 23
			elseif Arma_Total == 58 then
			    Aleatorio_Litros = 22
			elseif Arma_Total == 59 then
			    Aleatorio_Litros = 21
			elseif Arma_Total == 60 then
			    Aleatorio_Litros = 20
			elseif Arma_Total == 61 then
			    Aleatorio_Litros = 17
			elseif Arma_Total == 62 then
			    Aleatorio_Litros = 18
			elseif Arma_Total == 63 then
			    Aleatorio_Litros = 17
			elseif Arma_Total == 64 then
			    Aleatorio_Litros = 16
			elseif Arma_Total == 65 then
			    Aleatorio_Litros = 15
			elseif Arma_Total == 66 then
			    Aleatorio_Litros = 14
			elseif Arma_Total == 67 then
			    Aleatorio_Litros = 12
			elseif Arma_Total == 68 then
			    Aleatorio_Litros = 12
			elseif Arma_Total == 69 then
			    Aleatorio_Litros = 11
			elseif Arma_Total == 70 then
			    Aleatorio_Litros = 10
			elseif Arma_Total == 71 then
			    Aleatorio_Litros = 9
			elseif Arma_Total == 72 then
			    Aleatorio_Litros = 8
			elseif Arma_Total == 73 then
			    Aleatorio_Litros = 7
			elseif Arma_Total == 74 then
			    Aleatorio_Litros = 6
			elseif Arma_Total == 75 then
			    Aleatorio_Litros = 5
			elseif Arma_Total == 76 then
			    Aleatorio_Litros = 4
			elseif Arma_Total == 77 then
			    Aleatorio_Litros = 3
			elseif Arma_Total == 78 then
			    Aleatorio_Litros = 2
			elseif Arma_Total == 79 then
			    Aleatorio_Litros = 1
			elseif Arma_Total == 80 then
			    Aleatorio_Litros = 0
			elseif Arma_Total < 38 then
			    Aleatorio_Litros = math.random ( 5, 13 )
			end
    	    setElementData ( source, "Peketo_ArmaColetado", Arma_Total + Aleatorio_Litros )
	 	    local Arma_Total_Final = getElementData ( source, "Peketo_ArmaColetado" ) or 0
			Mensagem_Peketo ( source, "Sucesso: Você Acabou de Fabricar "..Aleatorio_Litros.." Armas, Totalizando em "..Arma_Total_Final.." Armas!", "success" )
		    triggerClientEvent ( root, "Peketo_VacaID_Nick", root, 8, "Ninguem" )
		    Vaca08_Estado = false
			setElementData ( source, "Peketo_Contagem_Arma_Estado", "Parado" )
		end, Tempo_Para_Coletar_Arma, 1 )
	else
	    local Arma_Total_Final = getElementData ( source, "Peketo_ArmaColetado" ) or 0
		Mensagem_Peketo ( source, "Erro: Você Já possui "..Arma_Total_Final.." Armas, Entre no Caminhão e de /Carregar!", "error" )
	end
end

--------------- // --------------- --------------- // --------------- --------------- // ---------------

local vehiclesToSpawn =
{
	{ Veiculo_Emprego_ID, -558.98431396484,2594.22265625,54.196083068848, -90, 0, 0 },
	{ Veiculo_Emprego_ID, -558.98431396484,2601.22265625,54.196083068848, -90, 0, 0 },
	{ Veiculo_Emprego_ID, -558.98431396484,2609.22265625,54.196083068848, -90, 0, 0 },
}

local vehicleDestroyTimers = {}
local playerVehicles = {}

local function destroyPlayerVehicles()
	local vehicles = playerVehicles[source]
	for _,vehicle in ipairs(vehicles) do
		if isElement(vehicle) then
			destroyElement(vehicle)
		end
	end
	playerVehicles[source] = nil
end

local function onEnter(player)
	local t = tonumber(get("vehicleRespawnTime")) or 60000
	source.damageProof = false
	source.frozen = false
	local vehicledata = vehiclesToSpawn[source]
	setTimer(createNewVehicle,(t > 50 and t or 50),1,vehicledata)
	vehiclesToSpawn[source] = nil
	if not playerVehicles[player] then
		playerVehicles[player] = {}
		addEventHandler("onPlayerQuit",player,destroyPlayerVehicles)
	end
	table.insert(playerVehicles[player],source)
	removeEventHandler("onVehicleEnter",source,onEnter)
end

local function destroyVehicle(vehicle)
	if vehicle and isElement(vehicle) and getElementType(vehicle) == "vehicle" then
		destroyElement(vehicle)
	end
end

local function destroyTimer()
	if vehicleDestroyTimers[source] and isTimer(vehicleDestroyTimers[source]) then killTimer(vehicleDestroyTimers[source]) end
	removeEventHandler("onVehicleEnter",source,destroyTimer)
end

local function onExit ( )
	local t = tonumber(get("vehicleExpireTime")) or 600000
	vehicleDestroyTimers[source] = setTimer(destroyVehicle,(t > 50 and t or 50),1,source)
	addEventHandler("onVehicleEnter",source,destroyTimer)
end

function VerificarEmprego ( thePlayer, seat )
    local Jogador = getElementData ( thePlayer, "Emprego" )
    if seat == 0 then
        if Jogador == "Fabricador De Armas" then
		    -- Entra no Veiculo (OK!)
		else
            cancelEvent ( )
            exports.Hype_MensagemDX:outputDx ( thePlayer, "Veiculo Exclusivo de Profissão!", "error" )
		end
    end
end

function createNewVehicle(vehicledata)
	local m,x,y,z,r = unpack(vehicledata)
	local vehicle = Vehicle(m,x,y,z,0,0,r)
	vehicle.damageProof = true
	vehicle.frozen = true
	vehiclesToSpawn[vehicle] = vehicledata
	addEventHandler("onVehicleEnter",vehicle,onEnter)
	addEventHandler("onVehicleExit",vehicle,onExit)
	addEventHandler("onVehicleStartEnter",vehicle,VerificarEmprego )
end

local function initScript()
	for _,vehicledata in ipairs(vehiclesToSpawn) do createNewVehicle(vehicledata) end
end
addEventHandler("onResourceStart",resourceRoot,initScript)

function Peketo_Receber_Rota_Fabricador ( Enviar_Estado_Rota, Final, Valor_Enviar )
    if isPedInVehicle ( source ) then
        local vh = getPedOccupiedVehicle ( source )
	    if isElement ( vh ) then
			local ID = getElementModel ( vh )
			if ID == 578 then
			    local seat = getPedOccupiedVehicleSeat ( source )
				if seat == 0 then
			    	local X_VEH, Y_VEH = getElementPosition ( vh )
		        	local X_PLAYER, Y_PLAYER = getElementPosition ( source )
		        	local Distancia = getDistanceBetweenPoints2D ( X_VEH, Y_VEH, X_PLAYER, Y_PLAYER )
					if Distancia > 0 then return end
					if isElementWithinMarker ( vh, Marker_Carregamento_Peketo ) then
    					setVisibleEmpresas ( source, false, "Finalizar" )
						setElementData ( source, "Valor_Frete_Fabricador", 0 )
    					local PosX, PosY, PosZ = getElementPosition ( source )
						local ObjetoID = 1558
						local Arma_Total_Jogador = getElementData ( source, "Peketo_ArmaColetado" ) or 0
						local Slot_de_Caixa = 1.2
						local Comeco = 1.7
						local Meio = 1.7 - Slot_de_Caixa
						local Fim = 1.7 - Slot_de_Caixa - Slot_de_Caixa
						local Comeco2 = -1.9
						local Meio2 = -1.9 - Slot_de_Caixa
						local Altura = 0.3
						local vh = getPedOccupiedVehicle ( source )
    					if Arma_Total_Jogador > 1 then
						    Caixa_01[source] = createObject ( ObjetoID, PosX, PosY, PosZ, 0, 0, 0 )
    						attachElements ( Caixa_01[source], vh, 0.67, Comeco, Altura )
    						Caixa_02[source] = createObject ( ObjetoID, PosX, PosY, PosZ, 0, 0, 0 )
    						attachElements ( Caixa_02[source], vh, -0.67, Comeco, Altura )
    					end
    					if Arma_Total_Jogador > 20 then
						    Caixa_03[source] = createObject ( ObjetoID, PosX, PosY, PosZ, 0, 0, 0 )
    						attachElements ( Caixa_03[source], vh, 0.67, Meio, Altura )
    						Caixa_04[source] = createObject ( ObjetoID, PosX, PosY, PosZ, 0, 0, 0 )
    						attachElements ( Caixa_04[source], vh, -0.67, Meio, Altura )
    					end
    					if Arma_Total_Jogador > 40 then
						    Caixa_05[source] = createObject ( ObjetoID, PosX, PosY, PosZ, 0, 0, 0 )
    						attachElements ( Caixa_05[source], vh, 0.67, Fim, Altura )
    						Caixa_06[source] = createObject ( ObjetoID, PosX, PosY, PosZ, 0, 0, 0 )
    						attachElements ( Caixa_06[source], vh, -0.67, Fim, Altura )
    					end
    					if Arma_Total_Jogador > 60 then
						    Caixa_07[source] = createObject ( ObjetoID, PosX, PosY, PosZ, 0, 0, 0 )
    						attachElements ( Caixa_07[source], vh, 0.67, Comeco2, Altura )
    						Caixa_08[source] = createObject ( ObjetoID, PosX, PosY, PosZ, 0, 0, 0 )
    						attachElements ( Caixa_08[source], vh, -0.67, Comeco2, Altura )
    					end
    					if Arma_Total_Jogador > 79 then
						    Caixa_09[source] = createObject ( ObjetoID, PosX, PosY, PosZ, 0, 0, 0 )
    						attachElements ( Caixa_09[source], vh, 0.67, Meio2, Altura )
							Caixa_10[source] = createObject ( ObjetoID, PosX, PosY, PosZ, 0, 0, 0 )
    						attachElements ( Caixa_10[source], vh, -0.67, Meio2, Altura )
    					end
						    
						outputChatBox ( "* Você carregou seu Caminhão com "..Arma_Total_Jogador.." Armas!", source )
						setElementData ( source, "Valor_Frete_Fabricador", Valor_Enviar )
						setVisibleEmpresas ( source, Enviar_Estado_Rota, Final )
						
					end					
				end
			end
		end
	end
end
addEvent( "Peketo_Enviar_Fabricador_Servidor", true)
addEventHandler( "Peketo_Enviar_Fabricador_Servidor", getRootElement ( ), Peketo_Receber_Rota_Fabricador )

function Finalizar_Entregar_Marker ( marker, md )
    if md then
	    if marker == Marker_Entrega_Final_LV_01 or marker == Marker_Entrega_Final_BS_01 or marker == Marker_Entrega_Final_MC_01 or marker == Marker_Entrega_Final_LS_01 or marker == Marker_Entrega_Final_LV_02 or marker == Marker_Entrega_Final_51_01 or marker == Marker_Entrega_Final_SF_01 or marker == Marker_Entrega_Final_SF_02 or marker == Marker_Entrega_Final_LS_02 then
	        local Emprego = getElementData ( source, "Emprego" ) or false
		    if Emprego == "Fabricador De Armas" then
		        local Rota = getElementData ( source, "Peketo_Fabricador_Para" ) or nil
		        if marker == Marker_Entrega_Final_LV_01 then
			        if Rota == "01" then
					    if isPedInVehicle ( source ) then
					        local vh = getPedOccupiedVehicle ( source )
					        if isElement ( vh ) then
					            local ID = getElementModel ( vh )
					            if ID == 578 then
					                local seat = getPedOccupiedVehicleSeat ( source )
					                if seat == 0 then
					                    local Pagamento_Final = getElementData ( source, "Valor_Frete_Fabricador" ) or 0
                                        setVisibleEmpresas ( source, false, Rota )
						                givePlayerMoney ( source, Pagamento_Final )
						                exports.Hype_MensagemDX:outputDx ( source, "Sucesso: Você Recebeu cerca de $"..Pagamento_Final.." pela Entrega!", "success" )
						                setElementData ( source, "Valor_Frete_Fabricador", 0 )
						                setElementData ( source, "Peketo_Fabricador_Para", nil )
						                setVisibleEmpresas ( source, false, "Finalizar" )
						                setElementData ( source, "Peketo_ArmaColetado", 0 )
									end
								end
							end
						end
				    end
			    elseif marker == Marker_Entrega_Final_BS_01 then
                    if Rota == "02" then
					    if isPedInVehicle ( source ) then
					        local vh = getPedOccupiedVehicle ( source )
					        if isElement ( vh ) then
					            local ID = getElementModel ( vh )
					            if ID == 578 then
					                local seat = getPedOccupiedVehicleSeat ( source )
					                if seat == 0 then
					                    local Pagamento_Final = getElementData ( source, "Valor_Frete_Fabricador" ) or 0
			    	                    setVisibleEmpresas ( source, false, Rota )
						                givePlayerMoney ( source, Pagamento_Final )
						                exports.Hype_MensagemDX:outputDx ( source, "Sucesso: Você Recebeu cerca de $"..Pagamento_Final.." pela Entrega!", "success" )
						                setElementData ( source, "Valor_Frete_Fabricador", 0 )
						                setElementData ( source, "Peketo_Fabricador_Para", nil )
						                setVisibleEmpresas ( source, false, "Finalizar" )
						                setElementData ( source, "Peketo_ArmaColetado", 0 )
						            end
						        end
						    end
						end
			    	end
			    elseif marker == Marker_Entrega_Final_MC_01 then
			        if Rota == "03" then
					    if isPedInVehicle ( source ) then
					        local vh = getPedOccupiedVehicle ( source )
					        if isElement ( vh ) then
					            local ID = getElementModel ( vh )
					            if ID == 578 then
					                local seat = getPedOccupiedVehicleSeat ( source )
					                if seat == 0 then
					    				local Pagamento_Final = getElementData ( source, "Valor_Frete_Fabricador" ) or 0
                        				setVisibleEmpresas ( source, false, Rota )
										givePlayerMoney ( source, Pagamento_Final )
										exports.Hype_MensagemDX:outputDx ( source, "Sucesso: Você Recebeu cerca de $"..Pagamento_Final.." pela Entrega!", "success" )
										setElementData ( source, "Valor_Frete_Fabricador", 0 )
										setElementData ( source, "Peketo_Fabricador_Para", nil )
										setVisibleEmpresas ( source, false, "Finalizar" )
										setElementData ( source, "Peketo_ArmaColetado", 0 )
						            end
						        end
						    end
						end
			    	end
			    elseif marker == Marker_Entrega_Final_LS_01 then
			        if Rota == "04" then
					    if isPedInVehicle ( source ) then
					        local vh = getPedOccupiedVehicle ( source )
					        if isElement ( vh ) then
					            local ID = getElementModel ( vh )
					            if ID == 578 then
					                local seat = getPedOccupiedVehicleSeat ( source )
					                if seat == 0 then
					    				local Pagamento_Final = getElementData ( source, "Valor_Frete_Fabricador" ) or 0
                        				setVisibleEmpresas ( source, false, Rota )
										givePlayerMoney ( source, Pagamento_Final )
										exports.Hype_MensagemDX:outputDx ( source, "Sucesso: Você Recebeu cerca de $"..Pagamento_Final.." pela Entrega!", "success" )
										setElementData ( source, "Valor_Frete_Fabricador", 0 )
										setElementData ( source, "Peketo_Fabricador_Para", nil )
										setVisibleEmpresas ( source, false, "Finalizar" )
										setElementData ( source, "Peketo_ArmaColetado", 0 )
						            end
						        end
						    end
						end
			    	end
			    elseif marker == Marker_Entrega_Final_LV_02 then
			        if Rota == "05" then
					    if isPedInVehicle ( source ) then
					        local vh = getPedOccupiedVehicle ( source )
					        if isElement ( vh ) then
					            local ID = getElementModel ( vh )
					            if ID == 578 then
					                local seat = getPedOccupiedVehicleSeat ( source )
					                if seat == 0 then
					    				local Pagamento_Final = getElementData ( source, "Valor_Frete_Fabricador" ) or 0
                        				setVisibleEmpresas ( source, false, Rota )
										givePlayerMoney ( source, Pagamento_Final )
										exports.Hype_MensagemDX:outputDx ( source, "Sucesso: Você Recebeu cerca de $"..Pagamento_Final.." pela Entrega!", "success" )
										setElementData ( source, "Valor_Frete_Fabricador", 0 )
										setElementData ( source, "Peketo_Fabricador_Para", nil )
										setVisibleEmpresas ( source, false, "Finalizar" )
										setElementData ( source, "Peketo_ArmaColetado", 0 )
						            end
						        end
						    end
						end
			    	end
			    elseif marker == Marker_Entrega_Final_51_01 then
			        if Rota == "06" then
					    if isPedInVehicle ( source ) then
					        local vh = getPedOccupiedVehicle ( source )
					        if isElement ( vh ) then
					            local ID = getElementModel ( vh )
					            if ID == 578 then
					                local seat = getPedOccupiedVehicleSeat ( source )
					                if seat == 0 then
					    				local Pagamento_Final = getElementData ( source, "Valor_Frete_Fabricador" ) or 0
                        				setVisibleEmpresas ( source, false, Rota )
										givePlayerMoney ( source, Pagamento_Final )
										exports.Hype_MensagemDX:outputDx ( source, "Sucesso: Você Recebeu cerca de $"..Pagamento_Final.." pela Entrega!", "success" )
										setElementData ( source, "Valor_Frete_Fabricador", 0 )
										setElementData ( source, "Peketo_Fabricador_Para", nil )
										setVisibleEmpresas ( source, false, "Finalizar" )
									    setElementData ( source, "Peketo_ArmaColetado", 0 )
						            end
						        end
						    end
						end
			    	end
			    elseif marker == Marker_Entrega_Final_SF_01 then
			        if Rota == "07" then
					    if isPedInVehicle ( source ) then
					        local vh = getPedOccupiedVehicle ( source )
					        if isElement ( vh ) then
					            local ID = getElementModel ( vh )
					            if ID == 578 then
					                local seat = getPedOccupiedVehicleSeat ( source )
					                if seat == 0 then
					    			    local Pagamento_Final = getElementData ( source, "Valor_Frete_Fabricador" ) or 0
                        			    setVisibleEmpresas ( source, false, Rota )
									    givePlayerMoney ( source, Pagamento_Final )
									    exports.Hype_MensagemDX:outputDx ( source, "Sucesso: Você Recebeu cerca de $"..Pagamento_Final.." pela Entrega!", "success" )
									    setElementData ( source, "Valor_Frete_Fabricador", 0 )
									    setElementData ( source, "Peketo_Fabricador_Para", nil )
									    setVisibleEmpresas ( source, false, "Finalizar" )
									    setElementData ( source, "Peketo_ArmaColetado", 0 )
						            end
						        end
						    end
						end
			    	end
			    elseif marker == Marker_Entrega_Final_SF_02 then
			        if Rota == "08" then
					    if isPedInVehicle ( source ) then
					        local vh = getPedOccupiedVehicle ( source )
					        if isElement ( vh ) then
					            local ID = getElementModel ( vh )
					            if ID == 578 then
					                local seat = getPedOccupiedVehicleSeat ( source )
					                if seat == 0 then
					    				local Pagamento_Final = getElementData ( source, "Valor_Frete_Fabricador" ) or 0
                        				setVisibleEmpresas ( source, false, Rota )
										givePlayerMoney ( source, Pagamento_Final )
										exports.Hype_MensagemDX:outputDx ( source, "Sucesso: Você Recebeu cerca de $"..Pagamento_Final.." pela Entrega!", "success" )
										setElementData ( source, "Valor_Frete_Fabricador", 0 )
										setElementData ( source, "Peketo_Fabricador_Para", nil )
								    	setVisibleEmpresas ( source, false, "Finalizar" )
								    	setElementData ( source, "Peketo_ArmaColetado", 0 )
									end
						        end
						    end
						end
			    	end
			    elseif marker == Marker_Entrega_Final_LS_02 then
			        if Rota == "09" then
					    if isPedInVehicle ( source ) then
					        local vh = getPedOccupiedVehicle ( source )
					        if isElement ( vh ) then
					            local ID = getElementModel ( vh )
					            if ID == 578 then
					                local seat = getPedOccupiedVehicleSeat ( source )
					                if seat == 0 then
					                    local Pagamento_Final = getElementData ( source, "Valor_Frete_Fabricador" ) or 0
		                                setVisibleEmpresas ( source, false, Rota )
						                givePlayerMoney ( source, Pagamento_Final )
						                exports.Hype_MensagemDX:outputDx ( source, "Sucesso: Você Recebeu cerca de $"..Pagamento_Final.." pela Entrega!", "success" )
						                setElementData ( source, "Valor_Frete_Fabricador", 0 )
						                setElementData ( source, "Peketo_Fabricador_Para", nil )
						                setVisibleEmpresas ( source, false, "Finalizar" )
						                setElementData ( source, "Peketo_ArmaColetado", 0 )
									end
								end
							end
						end
			    	end
				end
			end
		end
	end
end
addEventHandler ( "onPlayerMarkerHit", getRootElement ( ), Finalizar_Entregar_Marker )

function setVisibleEmpresas ( source, state, Numero )
	if state == true then
	    if Numero == "01" then
			setElementVisibleTo ( Marker_Entrega_Final_LV_01, source, true )
			setElementVisibleTo ( Bliper_Entrega_Final_LV_01, source, true )
		elseif Numero == "02" then
			setElementVisibleTo ( Marker_Entrega_Final_BS_01, source, true )
			setElementVisibleTo ( Bliper_Entrega_Final_BS_01, source, true )
		elseif Numero == "03" then
			setElementVisibleTo ( Marker_Entrega_Final_MC_01, source, true )
			setElementVisibleTo ( Bliper_Entrega_Final_MC_01, source, true )
		elseif Numero == "04" then
			setElementVisibleTo ( Marker_Entrega_Final_LS_01, source, true )
			setElementVisibleTo ( Bliper_Entrega_Final_LS_01, source, true )
		elseif Numero == "05" then
			setElementVisibleTo ( Marker_Entrega_Final_LV_02, source, true )
			setElementVisibleTo ( Bliper_Entrega_Final_LV_02, source, true )
		elseif Numero == "06" then
			setElementVisibleTo ( Marker_Entrega_Final_51_01, source, true )
			setElementVisibleTo ( Bliper_Entrega_Final_51_01, source, true )
		elseif Numero == "07" then
			setElementVisibleTo ( Marker_Entrega_Final_SF_01, source, true )
			setElementVisibleTo ( Bliper_Entrega_Final_SF_01, source, true )
		elseif Numero == "08" then
			setElementVisibleTo ( Marker_Entrega_Final_SF_02, source, true )
			setElementVisibleTo ( Bliper_Entrega_Final_SF_02, source, true )
		elseif Numero == "09" then
			setElementVisibleTo ( Marker_Entrega_Final_LS_02, source, true )
			setElementVisibleTo ( Bliper_Entrega_Final_LS_02, source, true )
		end
	end
	if state == false then
	    if Numero == "01" then
			setElementVisibleTo ( Marker_Entrega_Final_LV_01, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_LV_01, source, false )
		elseif Numero == "02" then
			setElementVisibleTo ( Marker_Entrega_Final_BS_01, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_BS_01, source, false )
		elseif Numero == "03" then
			setElementVisibleTo ( Marker_Entrega_Final_MC_01, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_MC_01, source, false )
		elseif Numero == "04" then
			setElementVisibleTo ( Marker_Entrega_Final_LS_01, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_LS_01, source, false )
		elseif Numero == "05" then
			setElementVisibleTo ( Marker_Entrega_Final_LV_02, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_LV_02, source, false )
		elseif Numero == "06" then
			setElementVisibleTo ( Marker_Entrega_Final_51_01, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_51_01, source, false )
		elseif Numero == "07" then
			setElementVisibleTo ( Marker_Entrega_Final_SF_01, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_SF_01, source, false )
		elseif Numero == "08" then
			setElementVisibleTo ( Marker_Entrega_Final_SF_02, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_SF_02, source, false )
		elseif Numero == "09" then
			setElementVisibleTo ( Marker_Entrega_Final_LS_02, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_LS_02, source, false )
		elseif Numero == "Finalizar" then
			setElementVisibleTo ( Marker_Entrega_Final_LV_01, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_LV_01, source, false )
			setElementVisibleTo ( Marker_Entrega_Final_BS_01, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_BS_01, source, false )
			setElementVisibleTo ( Marker_Entrega_Final_MC_01, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_MC_01, source, false )
			setElementVisibleTo ( Marker_Entrega_Final_LS_01, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_LS_01, source, false )
			setElementVisibleTo ( Marker_Entrega_Final_LV_02, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_LV_02, source, false )
			setElementVisibleTo ( Marker_Entrega_Final_51_01, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_51_01, source, false )
			setElementVisibleTo ( Marker_Entrega_Final_SF_01, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_SF_01, source, false )
			setElementVisibleTo ( Marker_Entrega_Final_SF_02, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_SF_02, source, false )
			setElementVisibleTo ( Marker_Entrega_Final_LS_02, source, false )
			setElementVisibleTo ( Bliper_Entrega_Final_LS_02, source, false )
			if isElement ( Caixa_01[source] ) then
			    destroyElement ( Caixa_01[source] )
			end
			if isElement ( Caixa_02[source] ) then
			    destroyElement ( Caixa_02[source] )
			end
			if isElement ( Caixa_03[source] ) then
			    destroyElement ( Caixa_03[source] )
    		end
    		if isElement ( Caixa_04[source] ) then
	    	    destroyElement ( Caixa_04[source] )
    		end
    		if isElement ( Caixa_05[source] ) then
	    	    destroyElement ( Caixa_05[source] )
    		end
    		if isElement ( Caixa_06[source] ) then
	    	    destroyElement ( Caixa_06[source] )
    		end
    		if isElement ( Caixa_07[source] ) then
	    	    destroyElement ( Caixa_07[source] )
    		end
    		if isElement ( Caixa_08[source] ) then
	    	    destroyElement ( Caixa_08[source] )
    		end
    		if isElement ( Caixa_09[source] ) then
	    	    destroyElement ( Caixa_09[source] )
    		end
			if isElement ( Caixa_10[source] ) then
	    	    destroyElement ( Caixa_10[source] )
    		end
			if isElement ( Caixa_11[source] ) then
	    	    destroyElement ( Caixa_11[source] )
    		end
			if isElement ( Caixa_12[source] ) then
	    	    destroyElement ( Caixa_12[source] )
    		end
			if isElement ( Caixa_13[source] ) then
	    	    destroyElement ( Caixa_13[source] )
    		end
			if isElement ( Caixa_14[source] ) then
	    	    destroyElement ( Caixa_14[source] )
    		end
		end
	end
end

function Sair_do_veh ( quitType )	
	if isElement ( Caixa_01[source] ) then
	    destroyElement ( Caixa_01[source] )
	end
	if isElement ( Caixa_02[source] ) then
	    destroyElement ( Caixa_02[source] )
	end
	if isElement ( Caixa_03[source] ) then
	    destroyElement ( Caixa_03[source] )
    end
    if isElement ( Caixa_04[source] ) then
	    destroyElement ( Caixa_04[source] )
    end
    if isElement ( Caixa_05[source] ) then
	    destroyElement ( Caixa_05[source] )
    end
    if isElement ( Caixa_06[source] ) then
	    destroyElement ( Caixa_06[source] )
    end
    if isElement ( Caixa_07[source] ) then
	    destroyElement ( Caixa_07[source] )
    end
    if isElement ( Caixa_08[source] ) then
	    destroyElement ( Caixa_08[source] )
    end
    if isElement ( Caixa_09[source] ) then
	    destroyElement ( Caixa_09[source] )
    end
	if isElement ( Caixa_10[source] ) then
	    destroyElement ( Caixa_10[source] )
    end
	if isElement ( Caixa_11[source] ) then
	    destroyElement ( Caixa_11[source] )
    end
	if isElement ( Caixa_12[source] ) then
	    destroyElement ( Caixa_12[source] )
    end
	if isElement ( Caixa_13[source] ) then
	    destroyElement ( Caixa_13[source] )
    end
	if isElement ( Caixa_14[source] ) then
	    destroyElement ( Caixa_14[source] )
    end
end
addEventHandler ( "onPlayerQuit", getRootElement ( ), Sair_do_veh )