MarkerSafeFluvial = createMarker( 2305.18286, -2395.12475, 13.33260, "cylinder", 200, 0, 255, 0, 0)

FluvialPickup = createPickup ( 2305.18286, -2395.12475, 13.33260, 3, 1210)
MarkerFluvial = createMarker ( 2305.18286, -2395.12475, 13.33260, "cylinder", 1.2, 255, 255, 255, 0 )
attachElements ( MarkerFluvial, FluvialPickup, 0, 0, -1 )
BlipFluvial = createBlipAttachedTo ( MarkerFluvial, 42 )
setBlipVisibleDistance ( BlipFluvial, 150 )

function CancelarSumirPickup ( player )
   cancelEvent()
end
addEventHandler ( "onPickupHit", FluvialPickup, CancelarSumirPickup )

LetraParaMarkers = "k"
cmd1 = "hq"
cmd2 = "profissao"

local HQFluvialBlip = createBlip ( 2305.18286, -2395.12475, 13.33260 )
setElementVisibleTo ( HQFluvialBlip, root, false )

--------------------------------------------------------------------

function VerificarBlipEmprego(player)
  if player then
  acc = getPlayerAccount ( player )
  if isGuestAccount ( acc ) then return end
  setElementVisibleTo ( HQFluvialBlip, player, false )
  end
end

setTimer(
function()
	for i, pl in pairs(getElementsByType("player")) do
		if pl ~= (false or nil) then
		    if getElementData ( pl, "Emprego" ) == "Transporte Fluvial" then return end
			   VerificarBlipEmprego(pl)
		end
	end
end,
3000,0)

--------------------------------------------------------------------

function ComandoHQ ( source )
    if getElementData ( source, "Emprego" ) == "Transporte Fluvial" then
	if isElementVisibleTo ( HQFluvialBlip, source ) then
	setElementVisibleTo ( HQFluvialBlip, source, false )
	exports.Hype_MensagemDX:outputDx(source, "Seu Local de Trabalho foi Desmarcado do Mapa!", "info")
	else
	setElementVisibleTo ( HQFluvialBlip, source, true )
	exports.Hype_MensagemDX:outputDx(source, "Seu Local de Trabalho foi Marcado no Mapa!", "info")
end
end	
end    
addCommandHandler ( cmd1, ComandoHQ )

--------------------------------------------------------------------

function AceitarEmprego02 (source)
exports.Hype_MsgsMarker:delete(source)
unbindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
if getElementData ( source, "Hype>Encaminhamento" ) == "Transporte Fluvial" then
setElementData ( source, "Hype>Encaminhamento", false )
setElementData ( source, "Emprego", "Transporte Fluvial" )
exports.Hype_MensagemDX:outputDx(source, "Você Agora Trabalha de Transporte Fluvial, Para Mais Informações Digite ( /Profissao )", "success")
else
exports.Hype_MensagemDX:outputDx(source, "Você Precisa Estar Encaminhado da Agencia de Empregos para Trabalhar neste Local!", "error")
end
end

function RecusarEmprego02 (source)
exports.Hype_MsgsMarker:delete(source)
unbindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
if isElementVisibleTo ( HQFluvialBlip, source ) then
setElementVisibleTo ( HQFluvialBlip, source, false )
end
removeElementData ( source, "Emprego", "Transporte Fluvial" )
exports.Hype_MensagemDX:outputDx(source, "Você se Demitiu do Emprego de Transporte Fluvial com Sucesso!", "warning")
end

--------------------------------------------------------------------

function ComandosProf ( ThePlayer )
if getElementData ( ThePlayer, "Emprego" ) == "Transporte Fluvial" then
playSoundFrontEnd ( ThePlayer, 43 )
outputChatBox ( "#F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #F96031Profissão #F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #BEE09AComandos da Profissão de Transporte Fluvial", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #55D444/HQ #ffffff- #9ABDE0Para Marcar / Desmarcar o seu Local de Trabalho", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #55D444/Rotas #ffffff- #9ABDE0Abre a Lista de Rotas Disponiveis Para Trabalhar", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #FFD700Entre no Barco e Digite /Rotas Selecione uma Rota e Voe Até o Local Selecionado!", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #F96031Profissão #F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~", ThePlayer, 255, 255, 255, true )
end
end
addCommandHandler(cmd2, ComandosProf )

--------------------------------------------------------------------

function emarker(marker,md) 
	if (md) then
	  if isPedInVehicle ( source ) then return end
		if marker == MarkerFluvial then
		    if getElementData ( source, "Emprego" ) == "Transporte Fluvial" then
			exports.Hype_MsgsMarker:create(source,"Aperte 'K' Para se Demitir do Emprego de Transporte Fluvial")
			bindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
		else
			exports.Hype_MsgsMarker:create(source,"Aperte 'K' Para Aceitar o Emprego de Transporte Fluvial")
			bindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
		end
	 end
  end	
end
addEventHandler("onPlayerMarkerHit",getRootElement(),emarker)

function lmarker(marker,md)
	if (md) then
		if marker == MarkerFluvial then
			exports.Hype_MsgsMarker:delete(source)			
			unbindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
			unbindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
		end
	end
end
addEventHandler("onPlayerMarkerLeave",getRootElement(),lmarker)

local vehiclesToSpawn =
{
	{ 452, 2300.9086914063, -2427.40234375, 0.4672557413578, 0 },
	{ 452, 2308.1513671875, -2420.220703125, 0.42523807287216, 0 },
	{ 452, 2314.6799316406, -2413.65625, 0.48500341176987, 0 },
}

local vehicleDestroyTimers = {}
local playerVehicles = {}

local function destroyPlayerVehicles()
	local vehicles = playerVehicles[source]
	for _,vehicle in ipairs(vehicles) do
		if isElement(vehicle) then
			destroyElement(vehicle)
		end
	end
	playerVehicles[source] = nil
end

local function onEnter(player)
	local t = tonumber(get("vehicleRespawnTime")) or 60000
	source.damageProof = false
	source.frozen = false
	local vehicledata = vehiclesToSpawn[source]
	setTimer(createNewVehicle,(t > 50 and t or 50),1,vehicledata)
	vehiclesToSpawn[source] = nil
	if not playerVehicles[player] then
		playerVehicles[player] = {}
		addEventHandler("onPlayerQuit",player,destroyPlayerVehicles)
	end
	table.insert(playerVehicles[player],source)
	removeEventHandler("onVehicleEnter",source,onEnter)
end

local function destroyVehicle(vehicle)
	if vehicle and isElement(vehicle) and getElementType(vehicle) == "vehicle" then
		destroyElement(vehicle)
	end
end

local function destroyTimer()
	if vehicleDestroyTimers[source] and isTimer(vehicleDestroyTimers[source]) then killTimer(vehicleDestroyTimers[source]) end
	removeEventHandler("onVehicleEnter",source,destroyTimer)
end

local function onExit()
	local t = tonumber(get("vehicleExpireTime")) or 600000
	vehicleDestroyTimers[source] = setTimer(destroyVehicle,(t > 50 and t or 50),1,source)
	addEventHandler("onVehicleEnter",source,destroyTimer)
end

function VerificarEmprego ( thePlayer, seat )
    local Jogador = getElementData ( thePlayer, "Emprego" )
    if seat == 0 then
        if Jogador == "Transporte Fluvial" then
		    -- Entra no Veiculo (OK!)
		else
            cancelEvent ( )
            exports.Hype_MensagemDX:outputDx ( thePlayer, "Veiculo Exclusivo de Profissão!", "error" )
		end
    end
end

function createNewVehicle(vehicledata)
	local m,x,y,z,r = unpack(vehicledata)
	local vehicle = Vehicle(m,x,y,z,0,0,r)
	vehicle.damageProof = true
	vehicle.frozen = true
	vehiclesToSpawn[vehicle] = vehicledata
	addEventHandler("onVehicleEnter",vehicle,onEnter)
	addEventHandler("onVehicleExit",vehicle,onExit)
	addEventHandler("onVehicleStartEnter",vehicle,VerificarEmprego )
end

local function initScript()
	for _,vehicledata in ipairs(vehiclesToSpawn) do createNewVehicle(vehicledata) end
end
addEventHandler("onResourceStart",resourceRoot,initScript)

--------------------------------------------------------------------

atualrotnumberBUSFluvial = {}
ppcikBUSFluvial = {}
blips = {}

rotasBUSFluvial = {
	["Los Santos até San Fierro ( Bayside Marina ) - $40000"] = {
		{-2205.670898,2421.5439,0.49366},
	},
	["Los Santos até Tierra Robada ( Usina Hidrelétrica ) - $35000"] = {
		{-796.16235,1812.70166,0.47652},
	},
	["Los Santos até San Fierro ( Esplanade North ) - $30000"] = {
		{-1890.70190,1399.63562,0.47667},
	},
	["Los Santos até San Fierro ( Esplanade East ) - $25000"] = {
		{-1476.72949,693.10577,0.47667},
	},
	["Los Santos até Las Venturas ( Red County ) - $20000"] = {
		{2358.50244,518.44354,0.47667},
	},
}

pay = {
	["Los Santos até San Fierro ( Bayside Marina ) - $40000"] = 40000,
	["Los Santos até Tierra Robada ( Usina Hidrelétrica ) - $35000"] = 35000,
	["Los Santos até San Fierro ( Esplanade North ) - $30000"] = 30000,
	["Los Santos até San Fierro ( Esplanade East ) - $25000"] = 25000,
	["Los Santos até Las Venturas ( Red County ) - $20000"] = 20000,
}

function ifPlayerEnterOnMarker(markerHit,matchingDimension)
	if isPedInVehicle(source) then
		if markerHit == ppcikBUSFluvial[source] then
			if (matchingDimension) then
				if isElement(ppcikBUSFluvial[source]) then
					local rname = getElementData(source,"rtnameBUSFluvial") or nil
					if rname == nil then return end
					destroyElement(ppcikBUSFluvial[source])
					triggerClientEvent(source,"Hype>JOBFluvial>blips<Client",source,false)
					local vh = getPedOccupiedVehicle(source)
					
					toggleAllControls ( source, false )
					setControlState ( source, "handbrake", true )
					
					if atualrotnumberBUSFluvial[source] <= #rotasBUSFluvial[rname] then
					    exports.Hype_MensagemDX:outputDx(source, "Desembarcando Passageiros... Aguarde 5 Segundos!", "info")
						setTimer(gerarrota,5000,1,source)
						--setTimer(function(source) exports.Hype_MensagemDX:outputDx(source, "Todos os Passageiros Embarcaram. Siga Para o Proximo Checkpoint!", "success") end,5000,1,source)
					elseif atualrotnumberBUSFluvial[source] == #rotasBUSFluvial[rname]+1 then
						setElementData(source,"rtnameBUSFluvial",rname)
						atualrotnumberBUSFluvial[source] = 1
						local rec = pay[rname]
						givePlayerMoney(source,tonumber(rec))	
						local vh = getPedOccupiedVehicle(source)
						setTimer(function(source) exports.Hype_MensagemDX:outputDx(source, "Você Recebeu um Valor de $"..rec.." Por Finalizar a Rota!", "success") end,5000,1,source)
						
						setElementData ( source, "HypeSCR_LiberarXP", "Sim" )
						
						setTimer(function(source) toggleAllControls ( source, true ) end, 5000,1, source )
						setTimer(function(source) setControlState ( source, "handbrake", false ) end, 5000,1, source )
						setElementData(source,"rtnameBUSFluvial",nil)	
					end

					
				end

			end	
		end
	end
end
addEventHandler("onPlayerMarkerHit",getRootElement(),ifPlayerEnterOnMarker)

--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function pickjobonbusBUS(source)
	if not isElement(source) then return end
	local im = isPedInVehicle(source)
	if im == false then return end	
	local job = getElementData(source,"Emprego") or false
	if job == "Transporte Fluvial" then
	local vh = getPedOccupiedVehicle(source)
	if isElement(vh) then
		local x,y = getElementPosition(vh)
		local x1,y1 = getElementPosition(source)
		local dist = getDistanceBetweenPoints2D(x,y,x1,y1)
		local isMarkerSafeFluvial = isElementWithinMarker(vh,MarkerSafeFluvial)
		local id = getElementModel(vh)
		local seat = getPedOccupiedVehicleSeat(source)
		if dist > 0 then return end
		if id == 452 then		
			if seat == 0 then
				if isMarkerSafeFluvial == false then return end
				triggerClientEvent(source,"Hype>JOBFluvial>AbrirPainel<Client",source,rotasBUSFluvial)
			end
		end
	end
end
end
addCommandHandler("rotas",pickjobonbusBUS)

function receivert(source,rotaname)
	if isElement(ppcikBUSFluvial[source]) then
		destroyElement(ppcikBUSFluvial[source])
	end	
	triggerClientEvent(source,"Hype>JOBFluvial>blips<Client",source,false)
	setElementData(source,"rtnameBUSFluvial",rotaname)
	atualrotnumberBUSFluvial[source] = 1
	gerarrota(source)
end
addEvent("Hype>request>Startrota>Server>Fluvial", true)
addEventHandler("Hype>request>Startrota>Server>Fluvial",getRootElement(), receivert)

function gerarrota(source)
	local rname = getElementData(source,"rtnameBUSFluvial") or nil
	if rname == nil then return end
	if not isElement(ppcikBUSFluvial[source]) and isPedInVehicle(source) then
		local vh = getPedOccupiedVehicle(source)
		toggleAllControls ( source, true )
		setControlState ( source, "handbrake", false )
		local id = tonumber(atualrotnumberBUSFluvial[source]) or nil
		local x,y,z = rotasBUSFluvial[rname][id][1],rotasBUSFluvial[rname][id][2],rotasBUSFluvial[rname][id][3]
		ppcikBUSFluvial[source] = createMarker (x, y,z, "checkpoint", 4, 255, 0, 0, 50,source)
		triggerClientEvent(source,"Hype>JOBFluvial>blips<Client",source,true,x,y,z)
		atualrotnumberBUSFluvial[source] = id+1
	end
end

function sair ( quitType )
	if isElement(ppcikBUSFluvial[source]) then
		destroyElement(ppcikBUSFluvial[source])
	end
end
addEventHandler ( "onPlayerQuit", getRootElement(), sair )

function SairDoOnibus ( thePlayer, seat, jacked )
   local rname = getElementData(thePlayer,"rtnameBUSFluvial") or nil
   if rname == nil then return end
   canceljobtimer (thePlayer)
   exports.Hype_MensagemDX:outputDx(thePlayer, "Você Saiu do Barco e Sua Rota foi Cancelada!", "warning")
end
addEventHandler ( "onVehicleExit", getRootElement(), SairDoOnibus )

function canceljobtimer(source)
	if isElement(ppcikBUSFluvial[source]) then
		destroyElement(ppcikBUSFluvial[source])
	end	
	triggerClientEvent(source,"Hype>JOBFluvial>blips<Client",source,false)	
	atualrotnumberBUSFluvial[source] = 1
	setElementData(source,"rtnameBUSFluvial",nil)	
end

function canceljobdeath()
	local job = getElementData(source,"Emprego") or false
	if job ~= "Transporte Fluvial" then return end
	local rname = getElementData(source,"rtnameBUSFluvial") or nil
	if rname == nil then return end
	canceljobtimer(source)
	exports.Hype_MensagemDX:outputDx(source, "Você Morreu e Sua Rota foi Cancelada!", "warning")
end	
addEventHandler( "onPlayerWasted", getRootElement( ),canceljobdeath)