MarkerSafeTransportadorDeDrogas = createMarker( -1110.3630371094, -1653.8610839844, 76.3671875, "cylinder", 35, 0, 255, 0, 0 )

TransportadorDeDrogasPickup = createPickup ( -1101.4787597656, -1639.0400390625, 76.3671875, 3, 1210)
MarkerTransportadorDeDrogas = createMarker ( -1101.4787597656, -1639.0400390625, 76.3671875, "cylinder", 1.2, 255, 255, 255, 0 )
attachElements ( MarkerTransportadorDeDrogas, TransportadorDeDrogasPickup, 0, 0, -1 )
BlipTransportadorDeDrogas = createBlipAttachedTo ( MarkerTransportadorDeDrogas, 42 )
setBlipVisibleDistance ( BlipTransportadorDeDrogas, 150 )

function CancelarSumirPickup ( player )
   cancelEvent()
end
addEventHandler ( "onPickupHit", TransportadorDeDrogasPickup, CancelarSumirPickup )

LetraParaMarkers = "k"
cmd1 = "hq"
cmd2 = "profissao"

local HQTransportadorDeDrogasBlip = createBlip ( -1101.4787597656, -1639.0400390625, 76.3671875 )
setElementVisibleTo ( HQTransportadorDeDrogasBlip, root, false )

--------------------------------------------------------------------

function VerificarBlipEmprego(player)
  if player then
  acc = getPlayerAccount ( player )
  if isGuestAccount ( acc ) then return end
  setElementVisibleTo ( HQTransportadorDeDrogasBlip, player, false )
  end
end

setTimer(
function()
	for i, pl in pairs(getElementsByType("player")) do
		if pl ~= (false or nil) then
		    if getElementData ( pl, "Emprego" ) == "Transportador de Drogas" then return end
			   VerificarBlipEmprego(pl)
		end
	end
end,
3000,0)

--------------------------------------------------------------------

ProX, ProY, TamX, TamY = -1142, -1700, 210, 100
ColRectangle_Fazenda = createColRectangle ( ProX, ProY, TamX, TamY )
Protecao_Fazenda = createRadarArea ( ProX, ProY, TamX, TamY, 0, 255, 0, 100 )

function Entrar_na_Fazenda ( thePlayer ) 
    if getElementData ( thePlayer, "ocupacao" ) == "Policial" then
	    outputChatBox ( "* AVISO: Policiais não são permitidos na Fazenda!", thePlayer, 255, 255, 255, true )
		--triggerClientEvent ( "HypeSCR_PolicialFazenda", thePlayer )
		if isPedInVehicle ( thePlayer ) then
		    local Veiculo = getPedOccupiedVehicle ( thePlayer )
			if Veiculo then
			    setElementPosition ( Veiculo, -1041, -1896, 78 )
			end
		else
		    setElementPosition ( thePlayer, -1041, -1896, 78 )
		end
	end
end
addEventHandler ( "onColShapeHit", ColRectangle_Fazenda, Entrar_na_Fazenda )

--------------------------------------------------------------------

function ComandoHQ ( source )
    if getElementData ( source, "Emprego" ) == "Transportador de Drogas" then
	if isElementVisibleTo ( HQTransportadorDeDrogasBlip, source ) then
	setElementVisibleTo ( HQTransportadorDeDrogasBlip, source, false )
	exports.Hype_MensagemDX:outputDx(source, "Seu Local de Trabalho foi Desmarcado do Mapa!", "info")
	else
	setElementVisibleTo ( HQTransportadorDeDrogasBlip, source, true )
	exports.Hype_MensagemDX:outputDx(source, "Seu Local de Trabalho foi Marcado no Mapa!", "info")
end
end	
end    
addCommandHandler ( cmd1, ComandoHQ )

--------------------------------------------------------------------

function AceitarEmprego02 (source)
exports.Hype_MsgsMarker:delete(source)
unbindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
if getElementData ( source, "Hype>Encaminhamento" ) == "Transportador de Drogas" then
setElementData ( source, "Hype>Encaminhamento", false )
setElementData ( source, "Emprego", "Transportador de Drogas" )
exports.Hype_MensagemDX:outputDx(source, "Você Agora Trabalha de Transportador de Drogas, Para Mais Informações Digite ( /Profissao )", "success")
else
exports.Hype_MensagemDX:outputDx(source, "Você Precisa Estar Encaminhado da Agencia de Empregos para Trabalhar neste Local!", "error")
end
end

function RecusarEmprego02 (source)
exports.Hype_MsgsMarker:delete(source)
unbindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
if isElementVisibleTo ( HQTransportadorDeDrogasBlip, source ) then
setElementVisibleTo ( HQTransportadorDeDrogasBlip, source, false )
end
removeElementData ( source, "Emprego", "Transportador de Drogas" )
exports.Hype_MensagemDX:outputDx(source, "Você se Demitiu do Emprego de Transportador de Drogas com Sucesso!", "warning")
end

--------------------------------------------------------------------

function ComandosProf ( ThePlayer )
if getElementData ( ThePlayer, "Emprego" ) == "Transportador de Drogas" then
playSoundFrontEnd ( ThePlayer, 43 )
outputChatBox ( "#F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #F96031Profissão #F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #BEE09AComandos da Profissão de Transportador de Drogas", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #55D444/HQ #ffffff- #9ABDE0Para Marcar / Desmarcar o seu Local de Trabalho", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #55D444/Rotas #ffffff- #9ABDE0Abre a Lista de Rotas Disponiveis Para Trabalhar", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #FFD700Entre na Van e Digite /Rotas Selecione uma Rota e Siga os Checkpoints!", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #F96031Profissão #F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~", ThePlayer, 255, 255, 255, true )
end
end
addCommandHandler(cmd2, ComandosProf )

--------------------------------------------------------------------

function emarker(marker,md) 
	if (md) then
	  if isPedInVehicle ( source ) then return end
		if marker == MarkerTransportadorDeDrogas then
		    if getElementData ( source, "Emprego" ) == "Transportador de Drogas" then
			exports.Hype_MsgsMarker:create(source,"Aperte 'K' Para se Demitir do Emprego de Transportador de Drogas")
			bindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
		else
			exports.Hype_MsgsMarker:create(source,"Aperte 'K' Para Aceitar o Emprego de Transportador de Drogas")
			bindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
		end
	 end
  end	
end
addEventHandler("onPlayerMarkerHit",getRootElement(),emarker)

function lmarker(marker,md)
	if (md) then
		if marker == MarkerTransportadorDeDrogas then
			exports.Hype_MsgsMarker:delete(source)			
			unbindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
			unbindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
		end
	end
end
addEventHandler("onPlayerMarkerLeave",getRootElement(),lmarker)

--------------- // --------------- --------------- // --------------- --------------- // ---------------

Veiculo_Emprego_ID = 483

local vehiclesToSpawn =
{
	{ Veiculo_Emprego_ID, -1114.0650634766, -1642.1851806641 -6, 76.323387145996, 270 },
	{ Veiculo_Emprego_ID, -1114.0650634766, -1642.1851806641 -12, 76.323387145996, 270 },
	{ Veiculo_Emprego_ID, -1114.0650634766, -1642.1851806641 -18, 76.323387145996, 270 },
}

local vehicleDestroyTimers = {}
local playerVehicles = {}

local function destroyPlayerVehicles()
	local vehicles = playerVehicles[source]
	for _,vehicle in ipairs(vehicles) do
		if isElement(vehicle) then
			destroyElement(vehicle)
		end
	end
	playerVehicles[source] = nil
end

local function onEnter(player)
	local t = tonumber(get("vehicleRespawnTime")) or 60000
	source.damageProof = false
	source.frozen = false
	local vehicledata = vehiclesToSpawn[source]
	setTimer(createNewVehicle,(t > 50 and t or 50),1,vehicledata)
	vehiclesToSpawn[source] = nil
	if not playerVehicles[player] then
		playerVehicles[player] = {}
		addEventHandler("onPlayerQuit",player,destroyPlayerVehicles)
	end
	table.insert(playerVehicles[player],source)
	removeEventHandler("onVehicleEnter",source,onEnter)
end

local function destroyVehicle(vehicle)
	if vehicle and isElement(vehicle) and getElementType(vehicle) == "vehicle" then
		destroyElement(vehicle)
	end
end

local function destroyTimer()
	if vehicleDestroyTimers[source] and isTimer(vehicleDestroyTimers[source]) then killTimer(vehicleDestroyTimers[source]) end
	removeEventHandler("onVehicleEnter",source,destroyTimer)
end

local function onExit ( )
	local t = tonumber(get("vehicleExpireTime")) or 600000
	vehicleDestroyTimers[source] = setTimer(destroyVehicle,(t > 50 and t or 50),1,source)
	addEventHandler("onVehicleEnter",source,destroyTimer)
end

function VerificarEmprego ( thePlayer, seat )
    local Jogador = getElementData ( thePlayer, "Emprego" )
    if seat == 0 then
        if Jogador == "Transportador de Drogas" then
		    -- Entra no Veiculo (OK!)
		else
            cancelEvent ( )
            exports.Hype_MensagemDX:outputDx ( thePlayer, "Veiculo Exclusivo de Profissão!", "error" )
		end
    end
end

function createNewVehicle(vehicledata)
	local m,x,y,z,r = unpack(vehicledata)
	local vehicle = Vehicle(m,x,y,z,0,0,r)
	vehicle.damageProof = true
	vehicle.frozen = true
	vehiclesToSpawn[vehicle] = vehicledata
	addEventHandler("onVehicleEnter",vehicle,onEnter)
	addEventHandler("onVehicleExit",vehicle,onExit)
	addEventHandler("onVehicleStartEnter",vehicle,VerificarEmprego )
end

local function initScript()
	for _,vehicledata in ipairs(vehiclesToSpawn) do createNewVehicle(vehicledata) end
end
addEventHandler("onResourceStart",resourceRoot,initScript)

--------------------------------------------------------------------

atualrotnumberDROGAS = {}
ppcikDROGAS = {}
blips = {}

rotasDROGAS = {
	["( Fazenda da Mafia --> Las Venturas ) por $6200"] = {
		{2193.6171875, 2723.8688964844, 10.8203125},
	},
	["( Fazenda da Mafia --> Los Santos ) por $5500"] = {
		{2362.361328125, -657.978515625, 128.08865356445},
	},
	["( Fazenda da Mafia --> San Fierro ) por $5000"] = {
		{-2171.8786621094, -217.64292907715, 35.3203125},
	},
}

pay = {
	["( Fazenda da Mafia --> Las Venturas ) por $62000"] = 6200,
	["( Fazenda da Mafia --> Los Santos ) por $5500"] = 5500,
	["( Fazenda da Mafia --> San Fierro ) por $5000"] = 5000,
}

function ifPlayerEnterOnMarker(markerHit,matchingDimension)
	if isPedInVehicle(source) then
		if markerHit == ppcikDROGAS[source] then
			if (matchingDimension) then
				if isElement(ppcikDROGAS[source]) then
					local rname = getElementData(source,"rtnameDrogas") or nil
					if rname == nil then return end
					destroyElement(ppcikDROGAS[source])
					triggerClientEvent(source,"Hype>JOBTransportadorDeDrogas>blips<Client",source,false)
					local vh = getPedOccupiedVehicle(source)
					
					toggleAllControls ( source, false )
					setControlState ( source, "handbrake", true )
					
					if atualrotnumberDROGAS[source] <= #rotasDROGAS[rname] then
					    exports.Hype_MensagemDX:outputDx(source, "Entregando Mercadoria... Aguarde 2 Segundos!", "info")
						
						setTimer(gerarrota,2500,1,source)
						setTimer(function(source) exports.Hype_MensagemDX:outputDx(source, "Mercadoria Entregue, Siga Para o Proximo Checkpoint!", "success") end,2500,1,source)
					elseif atualrotnumberDROGAS[source] == #rotasDROGAS[rname]+1 then
						setElementData(source,"rtnameDrogas",rname)
						atualrotnumberDROGAS[source] = 1
						local rec = pay[rname]
						givePlayerMoney(source,tonumber(rec))	
						local vh = getPedOccupiedVehicle(source)
						
						setElementData ( source, "HypeSCR_LiberarXP", "Sim" )
						
						setTimer(function(source) exports.Hype_MensagemDX:outputDx(source, "Você Recebeu um Valor de $"..rec.." Por Finalizar as Entregas de Drogas!", "success") end,2500,1,source)
						setTimer(function(source) toggleAllControls ( source, true ) end, 2500,1, source )
						setTimer(function(source) setControlState ( source, "handbrake", false ) end, 2500,1, source )
						setElementData(source,"rtnameDrogas",nil)	
					end

					
				end

			end	
		end
	end
end
addEventHandler("onPlayerMarkerHit",getRootElement(),ifPlayerEnterOnMarker)

--------------------------------------------------------------------

function pickjobDrogas(source)
	if not isElement(source) then return end
	local im = isPedInVehicle(source)
	if im == false then return end	
	local job = getElementData(source,"Emprego") or false
	if job == "Transportador de Drogas" then
		local vh = getPedOccupiedVehicle(source)
		if isElement(vh) then
			local x,y = getElementPosition(vh)
			local x1,y1 = getElementPosition(source)
			local dist = getDistanceBetweenPoints2D(x,y,x1,y1)
			local isMarkerSafe = isElementWithinMarker(vh,MarkerSafeTransportadorDeDrogas)
			local id = getElementModel(vh)
			local seat = getPedOccupiedVehicleSeat(source)
			if dist > 0 then return end
			if id == 483 then		
				if seat == 0 then
					if isMarkerSafe == false then return end
					triggerClientEvent(source,"Hype>JOBTransportadorDeDrogas>AbrirPainel<Client",source,rotasDROGAS)
				end
			end
		end
	end
end
addCommandHandler ( "rotas", pickjobDrogas )

function receivert(source,rotaname)
	if isElement(ppcikDROGAS[source]) then
		destroyElement(ppcikDROGAS[source])
	end	
	triggerClientEvent(source,"Hype>JOBTransportadorDeDrogas>blips<Client",source,false)
	setElementData(source,"rtnameDrogas",rotaname)
	atualrotnumberDROGAS[source] = 1
	gerarrota(source)
	exports.Hype_MensagemDX:outputDx(source, "Você Carregou sua Van com Drogas, vá até o local marcado no mapa para descarregar!", "warning")
	--Procurado = getPlayerWantedLevel ( source )
	--if Procurado < 6 then
	    --setPlayerWantedLevel ( source, Procurado + 1 )
		exports.Hype_EstrelaInfinita:HypeSCR_ANP_Server ( source, 1 )
	--end
end
addEvent("Hype>request>Startrota>Server>TransportadorDeDrogas", true)
addEventHandler("Hype>request>Startrota>Server>TransportadorDeDrogas",getRootElement(), receivert)

function gerarrota(source)
	local rname = getElementData(source,"rtnameDrogas") or nil
	if rname == nil then return end
	if not isElement(ppcikDROGAS[source]) and isPedInVehicle(source) then
		local vh = getPedOccupiedVehicle(source)
		toggleAllControls ( source, true )
		setControlState ( source, "handbrake", false )
		local id = tonumber(atualrotnumberDROGAS[source])
		local x,y,z = rotasDROGAS[rname][id][1],rotasDROGAS[rname][id][2],rotasDROGAS[rname][id][3]
		ppcikDROGAS[source] = createMarker (x, y,z, "checkpoint", 4, 255, 0, 0, 50,source)
		triggerClientEvent(source,"Hype>JOBTransportadorDeDrogas>blips<Client",source,true,x,y,z)
		atualrotnumberDROGAS[source] = id+1
	end
end

function sair ( quitType )
	if isElement(ppcikDROGAS[source]) then
		destroyElement(ppcikDROGAS[source])
	end
end
addEventHandler ( "onPlayerQuit", getRootElement(), sair )

function SairDaVAN ( thePlayer, seat, jacked )
   local rname = getElementData(thePlayer,"rtnameDrogas") or nil
   if rname == nil then return end
   canceljobtimer (thePlayer)
   exports.Hype_MensagemDX:outputDx(thePlayer, "Você Saiu da Van, Mercadoria Cancelada!", "warning")
end
addEventHandler ( "onVehicleExit", getRootElement(), SairDaVAN )

function canceljobtimer(source)
	if isElement(ppcikDROGAS[source]) then
		destroyElement(ppcikDROGAS[source])
	end	
	triggerClientEvent(source,"Hype>JOBTransportadorDeDrogas>blips<Client",source,false)	
	atualrotnumberDROGAS[source] = 1
	setElementData(source,"rtnameDrogas",nil)	
end

function canceljobdeath()
	local job = getElementData(source,"Emprego") or false
	if job ~= "Transportador de Drogas" then return end
	local rname = getElementData(source,"rtnameDrogas") or nil
	if rname == nil then return end
	canceljobtimer(source)
	exports.Hype_MensagemDX:outputDx(source, "Você Morreu e Suas Entregas Foram Canceladas!", "warning")
end	
addEventHandler( "onPlayerWasted", getRootElement( ),canceljobdeath)